# GQC -- Genome Quality Checker

The GQC python package analyses a user-supplied alignment of a test assembly to a benchmark assembly (preferably from the same sample), and prints general statistics, BED-formatted regions regarding the alignments and discrepancies within them, along with PDF-formatted plots. In addition, it reports statistics regarding discrepancies between aligned sequencing read sets and a benchmark that can help to elucidate sequencing platform strengths and weaknesses. Example outputs of various assembly and read benchmarking using GQC with the [HG002v1.1](https://github.com/marbl/HG002) assembly are available on [AWS](https://s3-us-west-2.amazonaws.com/human-pangenomics/index.html?prefix=T2T/HG002/assemblies/benchmarking/analyses/).

The program was written by Nancy Fisher Hansen, a staff scientist in the [Genome Informatics Section](https://genomeinformatics.github.io/), Center for Genomics and Data Science Research, National Human Genome Research Institute (NHGRI). Nancy can be reached at nhansen@mail.nih.gov. More complete documentation is available at [https://gqc.readthedocs.io](https://gqc.readthedocs.io).

## Table of contents
- [Install](#install)
- [Getting Started](#getting-started)
- [Program Outputs](#program-outputs)

# Install

## Dependencies

Running GQC's assembly benchmarking requires an installation of commit 38b07c2 or later of Gene Myers' [FASTK](https://github.com/thegenemyers/FASTK.git) package with its "KmerMap" and "FastK" commands in your path. When evaluating assemblies, GQC calls the [minimap2](https://github.com/lh3/minimap2) aligner, which should also be installed and in your path. For both assembly and read analyses, GQC uses R's Rscript command with [Bioconductor](https://www.bioconductor.org/) to create plots, and [bedtools](https://bedtools.readthedocs.io/en/latest/) to compare and merge intervals. If the "Rscript" command is not in a user's path, the program will complain, and perform all functions except plotting. If the "bedtools" command isn't in the user's path, the program will exit with an error. To use GQC's plotting functions, you will need to install the "stringr" package and the "karyoploteR" package, which are part of Bioconductor.

In addition, the program requires a set of files with data about the benchmark assembly you are comparing to. For the Q100 benchmark assembly hg002v1.1, a tarball of these files is available on [AWS](https://s3-us-west-2.amazonaws.com/human-pangenomics/T2T/HG002/assemblies/polishing/HG002/v1.1/benchmark/resources/hg002v1.1.resources.tar.gz). Once downloaded, this tarball should be unpacked and the first line in the file GQC/benchconfig.txt should be edited to specify the path of the downloaded resources directory (see the section "Config file" for more details).

All other dependencies will be installed by the pip installer with the commands in the next section called "Local Installation". Feel free to post installation issues to the issues section of this github repository and we will attempt to address them promptly.

## Local Installation

GQC is available on PyPi and can be installed with pip:
```
pip install GQC
```

Another easy way to install GQC is locally. This allows you to run the most up-to-date version of the code. First clone this github repository:
```
git clone https://github.com/marbl/GQC
cd GQC
```

At this point, edit the file "GQC/benchconfig.txt" and change the resource directory specified in the first line to the full path to the resource directory you downloaded from [AWS](https://s3-us-west-2.amazonaws.com/human-pangenomics/T2T/HG002/assemblies/polishing/HG002/v1.1/benchmark/resources/hg002v1.1.resources.tar.gz).

Create a virtual environment for the project:
```
python3 -m venv venv
source venv/bin/activate
```

Finally use python's pip installer to install and test a development copy for yourself to run:
```
python3 -m pip install -e .
pytest
```
# Getting Started

## Config file

In order to evaluate heterozygous sites, short tandem repeat run lengths, and other features of the genome benchmark, the GQC program needs specially formatted annotation files for the benchmark genomes. For hg002v1.1, these files are contained in a tarball available on [AWS](https://s3-us-west-2.amazonaws.com/human-pangenomics/T2T/HG002/assemblies/polishing/HG002/v1.1/benchmark/resources/hg002v1.1.resources.tar.gz). The program reads the locations of these files from a config file, which GQC assumes, by default, is a file called "benchconfig.txt" in your working directory, but the location of this file can also be specified with the -c or --config option. If the config file is not accessible in one of these two ways, the program will complain and exit.

An example config file is located [here](https://github.com/marbl/GQC/blob/main/GQC/benchconfig.txt) and contains the necessary parameters and file names. Edit that config file to specify the full path of the downloaded resources directory, and you can use that file as your config file when running the GQC or readbench commands.

## Evaluating haploid and diploid assemblies

To evaluate assembly scaffolds or contigs, the "bench" command first maps the locations of haplotype-specific 40-mers from the benchmark with the assembly's FASTA file. It then uses your installed version of minimap2 to create and trim alignments of each phased assembly sequence block to the appropriate benchmark haplotype.

	assemblybench -r <benchmark.fasta> -q <assembly.fasta> -p <prefix_for_output> -A <assembly_name> -B <benchmark_name>

For typical assemblies, the bench command will use about 64Gb of memory and around 4 hours run time on two processors. The command "GQC --help" will display information on other options available (e.g., to restrict regions of the genome examined, set minimum contig or alignment lengths for processing, etc.).

## Evaluating read sets

To report and plot statistics about discrepancies between a set of sequencing reads and a benchmark diploid genome, the program has a "readbench" command. First, the reads should be aligned to the diploid benchmark assembly with whatever aligner and parameters you feel are most accurate. The usage of the readbench command is

	readbench -b <reads_vs_benchmark.bam> -r <benchmark.fasta> -p <prefix_for_output> -B <benchmark_name> -R <readset_name>

Because it is evaluating more alignments than for an assembly evaluation, the readbench command takes longer to run than the GQC command. For this reason, it has a "--downsample" option which allows the user to pass a fraction between 0 and 1.0 that will cause read alignments to be randomly downsampled to include only that fraction of the alignments in its accuracy calculations. As with the GQC command, information about options can be obtained with "readbench --help".

## Comparing two assemblies

To compare two FASTA files for two different assemblies (a "query" assembly and a "reference" assembly) of the same genome (which need not be a benchmark genome), the program "assemblycompare" first phases the query assembly against the reference assembly using 40 basepair k-mers that are unique to one haplotype of the reference assembly. It then reports statistics for completeness of and discrepancies within alignments between query scaffolds and the appropriate haplotype of the reference assembly. The usage for "assemblycompare" is

	assemblycompare --q1fasta <queryhap1.fasta> --q2fasta <queryhap2.fasta> --r1fasta <refhap1.fasta> --r2fasta <refhap2.fasta> -p <prefix_for_output> -Q <query_assembly_name> -R <ref_assembly_name>

## Plotting GQC results for multiple assemblies together in single plots

It is possible to combine plots from multiple GQC assembly benchmarking runs into single plots using GQC's "multiplot" command. To produce plots containing the results from multiple GQC assembly benchmarking runs, create a tab-delimited input file with one line for each assembly GQC run. Each line's first four tab-delimited fields must be:

1. The path to the directory containing the assembly's "generalstats.txt" and other GQC output files. That directory should also contain the "alignclusterlengths.txt", the "singlenucerrorstats.txt", the "indelerrorstats.txt", and the "mononucstats.txt" files for that run.
2. The assembly name passed to GQC for the run (this is the string preceding ".generalstats.txt" in the general stats file name).
3. A label to be used for the assembly in legends and axis labels.
4. A shorter version of the label in the third column, for places where space is scarce. 

Optionally, you can add a fifth column to the assembly file containing a hex-formatted color (e.g., #6699CC) to be used in plots for that assembly. If you include a fifth column for one assembly, you must include five columns for all of them. If your file has only four columns, GQC's default colors will be used. The usage for "multiplot" is

	multiplot --inputfile <assembly file> --output <directory name for output plots> --config <GQC config file>

The config file option is not required if you have a GQC config file in your current working directory named "benchconfig.txt". The inputfile and output options are required, and the output directory will be created if it doesn't already exist.

# Program Outputs

All GQC programs create an output directory named with the prefix passed to the program with the --prefix (or -p) option. Within that directory will be a general statistics file, BED files, and pdf-formatted plots.

## GQC assembly evaluation outputs

### General statistics file

A file called "<assembly_name>.generalstats.txt" will contain general statistics about the assembly. The fasta file is first split into contigs anywhere the sequence contains at least 10 consecutive Ns (this value can be modified with the option --minns), and the number of scaffolds and contigs, the total bases within them, and statistics like N50/L50, NG50/LG50, and auNG are reported.

Then, the program evaluates the alignments of the phased scaffold segments to their corresponding benchmark genome haplotype, and reports similar statistics (NGA50/LGA50/auNGA) for these alignments, as well as the total number of bases aligned to each of the two benchmark haplotypes.

For each of the benchmark heterozygote sites provided in the benchmark's heterozygote bed file, the program will determine which of the two parental benchmark alleles is present in any of the haplotype alignments that cover the site. Then, for individual contig alignments, it will tally the number of times heterozygous sites within the alignment switch from maternal to paternal or vice-versa. From these switches and the lengths of the alignments, a switch rate is calculated and reported.

In evaluating accuracy, GQC tallies the number of discrepancies within primary alignments, and determines whether each represents the alternate allele of a heterozygous site. It then reports numbers of substitution and indel discrepancies and the number of these that match or don't match the alternate haplotype. From the total number of discrepancies and the total number of aligned bases, it reports a phred-scaled quality value (QV).

For each mono-, di-, tri-, and tetra- homopolymer run in the benchmark's short tandem repeat BED files, the bench program examines the assembly alignments that intersect the STR region. If the alignment has no discrepancies, it is considered "correct". If not and the assembly has a same-base run of a different length, its length is tallied, and if it has a different sequence, it is tallied as "complex". In the general statistics file, these categories are reported as "correct", "fewer or more of the same base", or "erroneous alleles other than extensions or contractions".

### BED files

The BED-formatted files produced by GQC include the following:

* excludedregions.<benchmark_name>.bed - regions that were excluded from analysis, either because they were in the config file's excluded regions, were not in regions specified with --includefile, and or were excluded with the --excludefile option
* nlocs.<assemblyhaplotype_name>.bed - regions with 10 or more Ns in the assembly haplotype (10 threshold can be modified with the --minns option)
* <assemblyhaplotype_name>.benchcovered.<benchmark_name>.bed - regions in the benchmark assembly covered alignments of assembly haplotype scaffolds
* testmatcovered.<assemlyhaplotype_name>.bed/testpatcovered.<assemblyhaplotype>.bed - regions in the assembly haplotype that align to maternal/paternal chromosomes in the benchmark
* <assemblyhaplotype_name>.errortype.<benchmark_name>.bed - benchmark locations of discrepancies in alignments, along with their locations in the test assembly haplotype
* <assemblyhaplotype_name>.mononucswithvariants.<benchmark_name>.bed - locations of benchmark mononucleotides covered by assembly alignments, with discrepancies

### Plots

Plot title names for the test assembly haplotype and the benchmark assembly are the names passed with the -A and -B options, respectively. The PDF-formatted plots currently produced by GQC are the following:

* <assemblyhaplotype_name>.benchcovered.<benchmark_name>.pdf - a karyotype plot of the benchmark diploid genome with maternal chromosomes on top and paternal chromosomes on bottom. Chromosomes are colored in wherever they are covered by an alignment of the tested assembly haplotype
* <assemblyhaplotype_name>.benchcoveredwitherrors.<benchmark_name>.pdf - same as the "benchcovered" plot, but with a wiggle plot of locations of discrepancies within alignments
* <assemblyhaplotype_name>.testcovered.<benchmark_name>.pdf - karyotype plot of test assembly scaffolds, colored to show where they align to maternal and paternal benchmark chromosomes
* <assemblyhaplotype_name>.indelsizestats.pdf - histogram of sizes of insertions and deletions within alignments of the test assembly haplotype to the benchmark genome
* <assemblyhaplotype_name>.mononuc_accuracy.<benchmark_name>.pdf - percent of mononucleotide runs accurate in the test assembly haplotype, plotted by mononucleotide length

## readbench sequencing read evaluation outputs

### General statistics file

A file called "<readset_name>.generalstats.txt" will report the total number of aligned read bases, the total number of clipped read bases, the total number of discrepancies within alignments (with a rate of discprepancies per aligned megabase), and the breakdown of these discrepancies into substitution and indel changes.

### Tab-delimited statistics files

* <readset_name>.singlenucerrorstats.txt - strand-specific nucleotide changes with the number observed and the rate they occur per aligned megabase. The first base in the reported change is the benchmark base (complemented if the read aligns along the reverse strand) and the second is the base reported within the read
* <readset_name>.indelerrorstats.txt - a tab-delimited file with the size of the observed insertion or deletion (negative is when bases from the benchmark are deleted in the read, positive when there are inserted bases in the read), the number observed, and the number observed per aligned megabase
* <readset_name>.readerrors.txt - a BED-formatted file with the locations of all tallied discrepancies between reads and the benchmark genome (keep in mind that when the --downsample option is used, these will not include all errors in all reads, just the ones in alignments that pass the downsampling threshold)

### Plots

* <readset_name>.indelsizestats.pdf - a histogram of the observed rates of indel discrepancies per aligned megabase of read

#setwd("/Users/nhansen/HG002_diploid_benchmark/plots/coverage_plots")

#if (!requireNamespace("BiocManager", quietly = TRUE))
  #install.packages("BiocManager")
#if (!requireNamespace("karyoploteR", quietly = TRUE))
  #BiocManager::install("karyoploteR")

library(stringr)
library(karyoploteR)
args = commandArgs(trailingOnly=TRUE)

genomename <- ifelse(!( is.na(args[1])), args[1], "year1pat")
benchname <- ifelse(!( is.na(args[2])), args[2], "v1.1")
outputdir <- ifelse(!( is.na(args[3])), args[3], ".")
genomefile <- ifelse(!( is.na(args[4])), args[4], ".")
nlocfile <- ifelse(!( is.na(args[5])), args[5], ".")
plottitle <- ifelse(!( is.na(args[6])), args[6], paste(c(benchname, " aligned coverage vs. ", genomename), sep="", collapse=""))
matstring <- ifelse(!( is.na(args[7])), args[7], "MAT")
benchgenome <- toGRanges(genomefile)
nlocranges <- toGRanges(nlocfile)

allchroms <- seqnames(benchgenome)
maternalchroms <- paste0("chr", c(1:22, "X"), "_MATERNAL")
paternalchroms <- paste0("chr", c(1:22, "Y"), "_PATERNAL")
chroms <- c(maternalchroms, paternalchroms)

#benchcoveredfile <- paste(c(outputdir, "/", genomename, ".benchcovered.", benchname, ".merged.bed"), sep="", collapse="")
benchcoveredfile <- paste(c(outputdir, "/", genomename, ".benchcovered.", benchname, ".bed"), sep="", collapse="")
benchcoveredranges <- toGRanges(benchcoveredfile)
benchcovereddf <- read.table(benchcoveredfile, header=FALSE, sep="\t")

errorfile <- paste(c(outputdir, "/", genomename, ".errortype.", benchname, ".bed"), sep="", collapse="")
errorsites <- read.table(errorfile, header=FALSE, sep="\t")
names(errorsites) <- c("chrom", "start", "end", "errorname", "score", "strand", "widestart", "wideend", "rgbcolor", "errortype", "assemblyerrorname")
namefieldlengths <- sapply(seq(1, length(errorsites$chrom)), function(x) {length(strsplit(errorsites$errorname[x], split="_")[[1]])})
errorsites$ref <- sapply(seq(1,length(errorsites$chrom)), function(x) {strsplit(errorsites$errorname[x], split="_")[[1]][[namefieldlengths[x] - 1]]})
errorsites$alt <- sapply(seq(1,length(errorsites$chrom)), function(x) {strsplit(errorsites$errorname[x], split="_")[[1]][[namefieldlengths[x]]]})

# calculate error profiles for error plot:

indelerrors <- errorsites[errorsites$errortype=="CONSENSUS" & (nchar(errorsites$alt)>1 | nchar(errorsites$ref)>1 | errorsites$alt=="*" | errorsites$ref=="*"),]
indelerrorgranges <- as(indelerrors, "GRanges")
snperrors <- errorsites[errorsites$errortype=="CONSENSUS" & nchar(errorsites$alt)==1 & nchar(errorsites$ref)==1 & errorsites$alt!="*" & errorsites$ref!="*",]
snperrorgranges <- as(snperrors, "GRanges")
phasingerrors <- errorsites[errorsites$errortype=="PHASING",]
phasingerrorgranges <- as(phasingerrors, "GRanges")

plotheatmaps <- function(kp, phasingerrors, snperrors, indelerrors) {
  chromlengths <- width(ranges(benchgenome))
  names(chromlengths) <- seqnames(benchgenome)
  windowranges <- tileGenome(seqlengths=chromlengths, tilewidth=1000000)
  phasingerrorcounts <- sapply(seq(1, length(windowranges)), function(x) {sum(phasingerrorgranges %over% windowranges[x])})
  kpHeatmap(kp, data=windowgranges, y=phasingerrorcounts, r0=0.1, r1=0.3, colors=c("lightblue", "blue", "black"))
  snperrorcounts <- sapply(seq(1, length(windowranges)), function(x) {sum(snperrorgranges %over% windowranges[x])})
  kpHeatmap(kp, data=windowgranges, y=snperrorcounts, data.panel=1, r0=0.4, r1=0.6, colors=c("lightgreen", "darkgreen", "black"))
  indelerrorcounts <- sapply(seq(1, length(windowranges)), function(x) {sum(indelerrorgranges %over% windowranges[x])})
  kpHeatmap(kp, data=windowgranges, y=indelerrorcounts, data.panel=1, r0=0.7, r1=0.9, colors=c("white", "pink", "red"))
  
}

plotlinecurves <- function(kp, phasingerrorgranges, snperrorgranges, indelerrorgranges) {
  kp <- kpPlotDensity(kp, data=phasingerrorgranges, data.panel=1, r0=0.1, r1=0.9, border="blue", col=NA, window.size=100000, fill=NULL, ymax=500)
  kp <- kpPlotDensity(kp, data=snperrorgranges, data.panel=1, r0=0.1, r1=0.9, col=NA, border="red", window.size=100000, ymax=500)
  kp <- kpPlotDensity(kp, data=indelerrorgranges, data.panel=1, r0=0.1, r1=0.9, col=NA, border="darkgreen", window.size=100000, ymax=500)
}

plotrectangles <- function(kp, phasingerrorgranges, snperrorgranges, indelerrorgranges) {
  kpRect(kp, data=phasingerrorgranges, border="blue", lwd=0.1, col="blue", data.panel=1, y0=rep(0, length(phasingerrorgranges)), y1=rep(0.2, length(phasingerrorgranges)))
  # then snps:
  kpRect(kp, data=snperrorgranges, border="red", lwd=0.1, col="red", data.panel=1, y0=rep(0.2, length(snperrorgranges)), y1=rep(0.4, length(snperrorgranges)))
  # then indels:
  kpRect(kp, data=indelerrorgranges, border="darkgreen", lwd=0.1, col="darkgreen", data.panel=1, y0=rep(0.4, length(indelerrorgranges)), y1=rep(0.6, length(indelerrorgranges)))
}

plot_coverage_vs_benchmark <- function(phasingerrorgranges=NA, snperrorgranges=NA, indelerrorgranges=NA) {
  pp <- getDefaultPlotParams(plot.type=1)
  pp$ideogramheight <- 100
  pp$topmargin <- 300

  # values that were used initially:
  #pp$ideogramheight <- 400
  #pp$data1height <- 1200
  #pp$data2height <- 1000
  #pp$topmargin <- 650
  
  bordercol = 'black'
  borderlwd = 0.2
  aligncolor <- ifelse(str_detect(benchcovereddf$V1, matstring), "green", "blue")
  kp <- plotKaryotype(genome=benchgenome, plot.type=1, chromosomes=chroms, main=plottitle, cex=0.5, plot.params=pp)
  kpAddBaseNumbers(kp, tick.dist = 20000000, tick.len = 10, cex=0.3)
  kpRect(kp, data=benchcoveredranges, border=bordercol, lwd=borderlwd, col=aligncolor, data.panel="ideogram", y0=rep(0, length(benchcoveredranges)), y1=rep(1, length(benchcoveredranges)))
  
  kpRect(kp, data=nlocranges, border=bordercol, lwd=borderlwd, col="red", data.panel="ideogram", y0=rep(0, length(nlocranges)), y1=rep(1, length(nlocranges)))
  
  legend("topright", inset = c(0,  0.075), c("Paternal", "Maternal", "N's (rDNAs)", "Uncovered"), fill=c("blue", "green", "red", "grey"), title="Aligned Regions")
  
  if ((length(phasingerrorgranges)>1 || !is.na(phasingerrorgranges)) && (length(snperrorgranges)>1 || !is.na(snperrorgranges)) && (length(indelerrorgranges)>1 || !is.na(indelerrorgranges))) {
    plotlinecurves(kp, phasingerrorgranges, snperrorgranges, indelerrorgranges)
    legend("bottomright", c("Phasing", "SingleNuc", "Indel"), col=c("blue", "red", "darkgreen"), lty=c(1,1,1,1), title="Error Type")
  }
}

covgplotname <- paste(c(outputdir, "/", genomename, ".benchcovered.", benchname, ".pdf"), sep="", collapse="")
pdf(covgplotname, 8.5, 11.0)
plot_coverage_vs_benchmark()
dev.off()

errorplotname <- paste(c(outputdir, "/", genomename, ".benchcoveredwitherrors.", benchname, ".pdf"), sep="", collapse="")
pdf(errorplotname, 8.5, 11.0)
plot_coverage_vs_benchmark(phasingerrorgranges, snperrorgranges, indelerrorgranges)
dev.off()

#setwd("/Users/nhansen/HG002_diploid_benchmark/plots/qualscores")

args = commandArgs(trailingOnly=TRUE)

genomename <- ifelse(!( is.na(args[1])), args[1], "lc24_medaka_hap1")
benchname <- ifelse(!( is.na(args[1])), args[2], "v1.1")
outputdir <- ifelse(!( is.na(args[3])), args[3], ".")
resourcedir <- ifelse(! ( is.na(args[4])), args[4], ".")
title <- ifelse(!( is.na(args[5])), args[5], paste(c(genomename, " accuracy of quality scores"), sep="", collapse=""))

qverrorsfile <- paste(c(outputdir, "/", genomename, ".qvstats.txt"), sep="", collapse="")

qvalues <- function(errorlist, totallist) {
  qscores <- sapply(seq(1, length(errorlist)), function(x) {return(ifelse(totallist[x]==0, NA, as.integer(-10.0*log10((errorlist[x]+1)/(totallist[x]+1)))))})
  return(qscores)
}

get_qv_counts <- function(file) {
  qvcounts <- read.table(file, header=FALSE, sep="\t")
  names(qvcounts) <- c("QVReported", "SNVErrors", "IndelErrors", "TotalBases")

  qvcounts$SNVObsQV <- qvalues(qvcounts$SNVErrors, qvcounts$TotalBases)
  qvcounts$IndelObsQV <- qvalues(qvcounts$IndelErrors, qvcounts$TotalBases)
  qvcounts$TotalObsQV <- qvalues((qvcounts$SNVErrors+qvcounts$IndelErrors), qvcounts$TotalBases)
  
  return(qvcounts)
}

qvcounts <- get_qv_counts(qverrorsfile)
condenseqvcounts <- function(qvcounts, windowsize=5) {
  numwindows <- as.integer(max(qvcounts$QVReported)/windowsize) + 1
  condensedcounts$SNVErrors <- sapply()
  return(numwindows)
}

makeqvplot <- function(qvcounts, cexfactor=0.05, plottitle="") {
  maxreported <- max(qvcounts[qvcounts$TotalBases>0, "QVReported"])
  plot(c(0,maxreported), c(0,maxreported), type="l", lty=2, main=plottitle, xlab="Reported QV", ylab="Observed QV")
  points(qvcounts$QVReported, qvcounts$TotalObsQV, pch=16, cex=cexfactor*log(qvcounts$TotalBases), col="black")
  points(qvcounts$QVReported, qvcounts$SNVObsQV, pch=16, cex=cexfactor*log(qvcounts$TotalBases), col="darkgreen")
  points(qvcounts$QVReported, qvcounts$IndelObsQV, pch=16, cex=cexfactor*log(qvcounts$TotalBases), col="blue")  #with(qvcounts, symbols(x=QVReported, y=TotalObsQV, circles=log(TotalBases), add=TRUE, inches=0.05, ann=F, bg="black", fg=NULL))
  legend(5, maxreported-5, c("Total QV", "SNV QV", "Indel QV"), pch=16, col=c("black", "darkgreen", "blue"))
  sizelegendsizes <- (c(2000, 200000, 20000000, 200000000, 2000000000))
  sizecexvals <- sapply(sizelegendsizes, function(x) {return(cexfactor*log(x))})
  legend(50, 20, as.character(sizelegendsizes), pch=16, col="black", pt.cex=sizecexvals, title="Total Bases")
}

plotname <- paste(c(outputdir, "/", genomename, ".qualvalue_accuracy_vs_", benchname, ".pdf"), sep="", collapse="")
pdf(plotname, 8.5, 5.5)
makeqvplot(qvcounts, plottitle=title)
dev.off()

library(stringr)

#setwd("/Users/nhansen/OneDrive/HPRC_assembly_comparison/data_for_Rplots/alignplots/hprc_minimap2")
args = commandArgs(trailingOnly=TRUE)

pardefault <- par()

chromname <- ifelse(!( is.na(args[1])), args[1], "HG01346#1#CM086596.1")
genomename <- ifelse(!( is.na(args[2])), args[2], "HG01346_HPRC")
benchname <- ifelse(!( is.na(args[3])), args[3], "HG01346_verkko_curated_y")
outputdir <- ifelse(!( is.na(args[4])), args[4], ".")
chromlength <- ifelse(! ( is.na(args[5])), as.integer(args[5]), 50304960)
refgapfile <- ifelse(! ( is.na(args[6])), args[6], NA)
querygapfile <- ifelse(! ( is.na(args[7])), args[7], NA)
vertline <- ifelse(! ( is.na(args[8])), as.integer(args[8]), NA)

# plot positions in megabases:
axisunitbases <- 1000000
safe_colorblind_palette <- c("#332288", "#88CCEE", "#CC6677", "#DDCC77", "#117733", "#AA4499", 
                             "#44AA99", "#999933", "#882255", "#661100", "#6699CC", "#888888",
			     "#648fff", "#fe6100", "#785ef0")

readaligns <- function(chromfile) {
  aligns <- read.table(chromfile, sep="\t", header=FALSE, comment.char="!")
  names(aligns) <- c("chrom", "start", "end", "alignname")

  aligns$start <- as.numeric(aligns$start)/axisunitbases
  aligns$end <- as.numeric(aligns$end)/axisunitbases
  aligns$query <- sapply(seq(1, length(aligns$alignname)), function(i) {us_fields <- strsplit(aligns$alignname, split="_"); return(paste(us_fields[[i]][1:(length(us_fields[[i]])-3)], sep="_", collapse="_"))})
  aligns$querystart <- sapply(seq(1, length(aligns$alignname)), function(i) {us_fields <- strsplit(aligns$alignname, split="_"); return(as.numeric(us_fields[[i]][length(us_fields[[i]]) - 2])/axisunitbases)})
  aligns$queryend <- sapply(seq(1, length(aligns$alignname)), function(i) {us_fields <- strsplit(aligns$alignname, split="_"); return(as.numeric(us_fields[[i]][length(us_fields[[i]]) - 1])/axisunitbases)})
  aligns$cluster <- sapply(seq(1, length(aligns$alignname)), function(i) {us_fields <- strsplit(aligns$alignname, split="_"); return(us_fields[[i]][length(us_fields[[i]])])})

  chromorderedaligns <- aligns[order(aligns$start, aligns$end), ]
  
  return(chromorderedaligns)
}

minpos <- function(aligns, contigname) {
  startsends <- c(aligns[aligns$query==contigname, "querystart"], aligns[aligns$query==contigname, "queryend"])
  return(min(startsends))
}

maxpos <- function(aligns, contigname) {
  startsends <- c(aligns[aligns$query==contigname, "querystart"], aligns[aligns$query==contigname, "queryend"])
  return(max(startsends))
}

minrefpos <- function(aligns, contigname) {
  startsends <- c(aligns[aligns$query==contigname, "start"], aligns[aligns$query==contigname, "end"])
  return(min(startsends))
}

maxrefpos <- function(aligns, contigname) {
  startsends <- c(aligns[aligns$query==contigname, "start"], aligns[aligns$query==contigname, "end"])
  return(max(startsends))
}

contiginfo <- function(aligns) {
  
  ctginfo <- data.frame("contigname"=unique(aligns$query))
  ctginfo$minpos <- sapply(ctginfo$contigname, function(x) {minpos(aligns, x)})
  ctginfo$maxpos <- sapply(ctginfo$contigname, function(x) {maxpos(aligns, x)})
  ctginfo$minrefpos <- sapply(ctginfo$contigname, function(x) {minrefpos(aligns, x)})
  ctginfo$maxrefpos <- sapply(ctginfo$contigname, function(x) {maxrefpos(aligns, x)})
  ctginfo$basescovered <- ctginfo$maxpos - ctginfo$minpos
  
  return(ctginfo)
}


orderedcontigs <- function(aligns) {
  ctginfo <- contiginfo(aligns) 
  orderedctginfo <- ctginfo[order(ctginfo$minrefpos, decreasing = TRUE), ]
  
  return(orderedctginfo)
}


multiplotaligns <- function(aligns, chromlength=NA, chromplotfile=NA, minfrac=0.5, refgapfile=NA, querygapfile=NA, vertlinepos=NA, maxqueryentries=10, suppresstitle=FALSE, chrommin=NA, chrommax=NA, querymin=NA, querymax=NA, unitbases=axisunitbases, querytickdistance=10) {

  chromname <- unique(aligns[1]["chrom"])  
  # largeclusterqueryaligninfo dataframe has only the contig names for contigs in the large clusters of alignments:
  largeclusterqueryaligninfo <- data.frame(query=unique(aligns[!str_detect(aligns$cluster, "Small"), "query"]))
  # querybasescovered is the total aligned bases in each contig (including those aligned within small clusters)
  largeclusterqueryaligninfo$querybasescovered <-sapply(largeclusterqueryaligninfo$query, function(x) {querycoverage(aligns, x)})
  largeclusterqueryaligninfo$refbasescovered <-sapply(largeclusterqueryaligninfo$query, function(x) {refcoverage(aligns, x)})
  largeclusterqueryaligninfo$minrefpos <-sapply(largeclusterqueryaligninfo$query, function(x) {minrefpos(aligns, x)})
  largeclusterqueryaligninfo$minquerypos <-sapply(largeclusterqueryaligninfo$query, function(x) {minpos(aligns, x)})
  largeclusterqueryaligninfo$maxquerypos <-sapply(largeclusterqueryaligninfo$query, function(x) {maxpos(aligns, x)})  # probably want to added some kind of position-weighted average ref coordinate measure
  largeclusterqueryaligninfo$queryaxislength <-sapply(largeclusterqueryaligninfo$query, function(x) {largeclusterqueryaligninfo[largeclusterqueryaligninfo$query==x, "maxquerypos"]-largeclusterqueryaligninfo[largeclusterqueryaligninfo$query==x, "minquerypos"]})

  # don't bother to plot any alignments if total aligned query bases are less than minfrac (0.5) of the ref chrom length:
  coveredbases <- sum(largeclusterqueryaligninfo$querybasescovered)
  halfchromlength <- 0.5*chromlength/unitbases
  if (coveredbases < halfchromlength) {
    return(0)
  }

  # open the file to plot to if there is one:
  if (!is.na(chromplotfile)) {
    pdf(chromplotfile, 8.5, 11.0)
  }

  # read in gaps if there are gap files:
  refgaps <- gaplocs(refgapfile)
  querygaps <- gaplocs(querygapfile)

  # store graph parameters so they can be restored after changing:
  par(pardefault)
  
  # order the contigs along the reference chromosome and calculate pseudocoordinates:
  positionorderedqueryinfo <- largeclusterqueryaligninfo[order(largeclusterqueryaligninfo$minrefpos, decreasing=FALSE), ]
  numsections <- min(length(largeclusterqueryaligninfo$query), maxqueryentries)
  positionorderedqueryinfo$pseudostart <- sapply(seq(1, length(positionorderedqueryinfo$query)), function(x) { if (x==1) {return(0)} else {return(sum(positionorderedqueryinfo[1:(x-1), "queryaxislength"]))} })
  positionorderedqueryinfo$pseudoend <- sapply(seq(1, length(positionorderedqueryinfo$query)), function(x) { return(sum(positionorderedqueryinfo[(1:x), "queryaxislength"])) })

  bigcontiglist <- unique(positionorderedqueryinfo[ , "query"])
  bigcontigaligns <- lapply(positionorderedqueryinfo$query, function(x) {return(aligns[aligns$query==x, ])})

  bigcontigalignlist <- aligns[is.element(aligns$query, bigcontiglist),]
  contigclusters <- unique(bigcontigalignlist$cluster)
  nonsmallcontigclusters <- contigclusters[!str_detect(contigclusters, "Small")]
  
  clusterpalette <- safe_colorblind_palette[1:length(nonsmallcontigclusters)]
  bigclustercolors <- data.frame("clustername"=nonsmallcontigclusters, "clustercolor"=clusterpalette)
 
  orderedclusters <- str_sort(contigclusters, numeric=TRUE)
 
  #orderedclusters <- contigclusters[order(contigclusters)]
  legendclustercolors <- sapply(orderedclusters, function(x) {
    ifelse(str_detect(x, "Small"), "black", clusterpalette[which(nonsmallcontigclusters==x, arr.ind=TRUE)] )
  })
  
  plottitle <- ifelse(suppresstitle, "", paste("Alignments of ", genomename, " to ", benchname))
  xlabval <- paste(c(chromname, " (Mb)"), sep="", collapse="" )
  if (is.na(chrommin)) {
    chrommin <- min(positionorderedqueryinfo$minrefpos)
  }
  if (is.na(chrommax)) {
    chrommax <- chromlength/unitbases
  }
  if (is.na(querymin)) {
    querymin <- 0
  }
  if (is.na(querymax)) {
    querymax <- max(positionorderedqueryinfo$pseudoend + 1)
  }
  
  plot(list(), list(), main=plottitle, xaxs='i', yaxt='n', xlab=xlabval, yaxs='i', ylab="", 
       xlim=c(chrommin, chrommax), ylim=c(querymin, querymax))

  contigdividelines <- positionorderedqueryinfo$pseudostart
  abline(h=contigdividelines[-1])

  alltickpseudopositions = c()
  allticklabels = c()
  for(contigaligns in bigcontigaligns) {
    contigname <- unique(contigaligns$query)[[1]]
    contigmin <- positionorderedqueryinfo[positionorderedqueryinfo$query==contigname, "minquerypos"]
    contigmax <- positionorderedqueryinfo[positionorderedqueryinfo$query==contigname, "maxquerypos"]
    contigpseudostart <- positionorderedqueryinfo[positionorderedqueryinfo$query==contigname, "pseudostart"]
    contigpseudoend <- positionorderedqueryinfo[positionorderedqueryinfo$query==contigname, "pseudoend"]
    if ((ceiling(contigmin/querytickdistance) < contigmax/querytickdistance) && (floor(contigmax/querytickdistance) > contigmin/querytickdistance)) {
      contigtickpositions <- querytickdistance*seq.int(ceiling(contigmin/querytickdistance), floor(contigmax/querytickdistance))
    }
    else {
      contigtickpositions <- c()
    }
    contigtickpseudopositions <- contigtickpositions + contigpseudostart - contigmin
    contigticklabels <- as.character(contigtickpositions)
    alltickpseudopositions <- c(alltickpseudopositions, contigtickpseudopositions)
    allticklabels <- c(allticklabels, contigticklabels)
    segmentx0vals <- contigaligns$start
    segmentx1vals <- contigaligns$end
    segmenty0vals <- sapply(seq(1, length(contigaligns$query)), function(x) { contigaligns[x, "querystart"] + contigpseudostart - contigmin})
    segmenty1vals <- sapply(seq(1, length(contigaligns$query)), function(x) { contigaligns[x, "queryend"] + contigpseudostart - contigmin})
    segmentcolors <- sapply(contigaligns$cluster, function(x) {
      ifelse(str_detect(x, "Small"), "black", bigclustercolors[which(bigclustercolors$clustername==x, arr.ind=TRUE), "clustercolor"] )
    })

    cexfactor <- 0.8 # will want to adjust this with the lengths of the contig names
    contiglabelheight <- (contigpseudostart + contigpseudoend)/2.0
    if ((querymin != 0) & ((contigpseudostart <= querymin) | (contigpseudoend >= querymax))) {
      # adjust height of label
      contiglabelheight <- ((querymin + querymax)/2.0)
    }
    #return(contiglabelheight)
    if (contigpseudoend - contigpseudostart > 10) {
      mtext(contigname, side=2, line=2, at=contiglabelheight, cex=cexfactor)
    }
    
    segments(x0=segmentx0vals, y0=segmenty0vals, x1=segmentx1vals, y1=segmenty1vals, col=segmentcolors, lwd=1.5)
  }
  # ticks/labels:
  
  inboundarytickmarks <- which(alltickpseudopositions>querymin & alltickpseudopositions<querymax)
  axis(side=2, at=alltickpseudopositions, labels = allticklabels)

  if (!(is.na(vertlinepos))) {
    abline(v=vertlinepos, lty=4)
    if (!is.na(vertlinelabel)) {
      text(vertlinepos+2, 1, labels= vertlinelabel)
    }
  }
  if (length(refgaps)>1 || !(is.na(refgaps))) {
    refstarts <- refgaps[refgaps$contig==chrom, "start"]/unitbases
    refends <- refgaps[refgaps$contig==chrom, "end"]/unitbases
    if (length(refstarts) > 0) {
      rect(refstarts, querymin, refends, querymax, col="gray")
    }
  }
  if (length(querygaps)>1 || !(is.na(querygaps))) {
    querystarts <- querygaps[querygaps$contig==chrom, "start"]/unitbases
    queryends <- querygaps[querygaps$contig==chrom, "end"]/unitbases
    if (length(querystarts) > 0) {
      rect(chrommin, querystarts, chrommax, queryends, col="gray")
    }
  }
  
  legend("bottomright", orderedclusters, pch=15, col=legendclustercolors)
  
  if (!is.na(chromplotfile)) {
    dev.off()
  }

}

querycoverage <- function(aligns, queryname) {
  queryaligns <- aligns[aligns$query==queryname, ]
  covgsum <- sum(abs(queryaligns$queryend - queryaligns$querystart + 1))
  
  return(covgsum)
}

refcoverage <- function(aligns, queryname) {
  queryaligns <- aligns[aligns$query==queryname, ]
  covgsum <- sum(abs(queryaligns$end - queryaligns$start + 1))
  
  return(covgsum)
}

gaplocs <- function(bedfile) {

  if (!is.na(bedfile)) {
    gaps <- read.table(bedfile, sep="\t", header=FALSE, comment.char="!")
    names(gaps) <- c("contig", "start", "end", "gapname")    
  } else {
    gaps <- NA
  }
  
  return(gaps)
}

chromfiles <- list.files(outputdir, pattern = paste(c('.', chromname, '.clusters.bed'), sep="", collapse=""))
aligns <- c()
for (file in chromfiles) {
  aligns <- rbind(aligns, readaligns(paste(c(outputdir, "/", file), sep="", collapse="")))
}
chromplotfile <- paste(outputdir, "/", chromname, ".clustered_aligns.pdf", sep="", collapse="")

if (is.na(vertline)) {
  multiplotaligns(aligns, chromlength=chromlength, chromplotfile, refgapfile=refgapfile, querygapfile=querygapfile) 
} else {
  multiplotaligns(aligns, chromlength=chromlength, chromplotfile, refgapfile=refgapfile, querygapfile=querygapfile, yqhstart=vertline)  
}

library(colorspace)
library(Hmisc)

assemblycolors <- c("#44AA99", "#332288", "#882255", "#888888", "#DDCC77", "#661100", "#6699CC")
methodcolors <- c("#DDCC77", "#661100", "#6699CC")

readlengths <- function(sizefile) {
  clusterlengths <- read.table(sizefile, sep="\t", header=FALSE)
  names(clusterlengths) <- c("perc", "clusterlength", "totallength", "chromosome")
  clusterlengths$clusterlength <- clusterlengths$clusterlength/1000000
  
  return(clusterlengths)
}

readideallengths <- function(bedfile) {
  idealdf <- read.table(bedfile)
  idealdf$lengths <- (as.integer(idealdf$V3)-as.integer(idealdf$V2))/1000000
  
  totallengths <- sum(idealdf$lengths)
  sortedlengths <- sort(idealdf$lengths, decreasing=TRUE)
  perccovered <- sapply(seq(1, length(sortedlengths)), function(i) {return(100*sum(sortedlengths[seq(1,i)])/totallengths)})
  
  return(data.frame(clusterlength=sortedlengths, perc=perccovered))
}

plotclusterlengths <- function(clusterlengths, color="red", title="NGAx", dashed=FALSE, ltyval=NA, cexval=1.0, xmax=100, xlabel=NA) {
  xcoords <- append(0, clusterlengths$perc)
  ycoords <- c(clusterlengths$clusterlength, 0)
  if (is.na(ltyval)) {
    ltyval <- ifelse(dashed, 2, 1)
  }
  if (is.na(xlabel)) {
    xlabel="Percent of Diploid Genome"
  }
  plot(xcoords, ycoords, type="s", col=color, lty=ltyval, xlim=c(0,xmax), ylim=c(0,250), xlab=xlabel, ylab="Aligned length (Mb)", main=title, cex=cexval)
}

addclusterlengths <- function(clusterlengths, color="blue", dashed=FALSE, ltyval=NA) {
  xcoords <- append(0, clusterlengths$perc)
  ycoords <- c(clusterlengths$clusterlength, 0)
  if (is.na(ltyval)) {
    ltyval <- ifelse(dashed, 2, 1)
  }
  lines(xcoords, ycoords, type="s", col=color, lty=ltyval, xlim=c(0,100))
}


assembly_ngax_plot <- function(clusterfiles, contigfiles=c(), scaffoldfiles=c(), assemblylabels=c(), ideal=FALSE, idealname='HG002v1.1', idealfile="", aung=TRUE, haplotype=NA, plottitle="", cexval=1.0) {
  
  firstclusters <- readlengths(clusterfiles[1]) 
  totalalignedlength <- sum(firstclusters$clusterlength)
  totallengthsquared <- sum(firstclusters$clusterlength*firstclusters$clusterlength)
  aung <- as.integer(totallengthsquared/totalalignedlength + 0.5)

  plotclusterlengths(firstclusters, col=assemblycolors[1], title=plottitle, lty=1, cexval=cexval)
  if (length(contigfiles) > 1) {
    firstcontigs <- readlengths(contigfiles[1]) 
    addclusterlengths(firstcontigs, col=assemblycolors[1])    
  }
  if (length(scaffoldfiles) > 1) {
    firstscaffolds <- readlengths(scaffoldfiles[1]) 
    addclusterlengths(firstscaffolds, col=assemblycolors[1])    
  }
  
  if (length(clusterfiles) > 1) {
    for (i in seq(2, length(clusterfiles))) {
      addclusterlengths(readlengths(clusterfiles[i]), col=assemblycolors[i], lty=1)
    }
  }
  if (ideal && idealfile != "") {
    ideallengths <- readideallengths(idealfile)
    addclusterlengths(ideallengths, col="black")
    assemblycolors <- c(assemblycolors[1:length(assemblylabels)], "black")
    assemblylabels <- c(assemblylabels, paste0(c("Ideal (", idealname, ")"), sep="", collapse=""))
  }
  legend("topright", assemblylabels, col=assemblycolors, bty="n", lty=rep(1, length(clusterfiles)))
  if (aung) {
    aunglabel=paste(c("auNGA: ", aung, "Mb"), sep="", collapse="")
    text(20, 50, labels=aunglabel)
  }
}

##### END NG/NGAx Plotting Routines #####

##### START Homopolymer Accuracy Curve Plotting Routines #####

readmnstatsfile <- function(filename) {
  mnstats <- read.table(filename, header=FALSE, sep="\t", col.names=c("name", "base", "reflength", "assemblylength", "type"))

  return(mnstats)
}

mononucaccuracystats <- function(mnstats) {
  consensuserrors <- mnstats[(mnstats$assemblylength != -1) & (mnstats$type == "CONSENSUS") & (mnstats$reflength < 100) & (mnstats$reflength >= 10), ]
  noncomplexcovered <- mnstats[(mnstats$assemblylength != -1) & (mnstats$reflength < 100) & (mnstats$reflength >= 10), ]
  consensuserrorcounts <- hist(consensuserrors$reflength, plot=FALSE, breaks=seq(10, 100, 1))
  noncomplexcovcounts <- hist(noncomplexcovered$reflength, plot=FALSE, breaks=seq(10, 100, 1))
  accrate <- 1.0 - consensuserrorcounts$counts/noncomplexcovcounts$counts
  correctcalls <- noncomplexcovcounts$counts - consensuserrorcounts$counts

  return(data.frame(lengths=consensuserrorcounts$mids, errors=consensuserrorcounts$counts, correctcalls=correctcalls, totals=noncomplexcovcounts$counts, accuracy=accrate) )
}

assembly_mononucacc_plot <- function(mnstatsfiles=c(), assemblylabels=c(), plottitle="", pointcex=1.0, errorbars=FALSE, legendxpos=15, legendypos=0.6) {
  pchvalues <- c(15, 16, 17, 18, 15, 16, 17, 18, 15, 16, 17, 18)
  multiplevector <- c(1.4, 1.4, 1.4, 1.9, 1.4, 1.4, 1.4, 1.4, 1.4, 1.4, 1.4, 1.9)
  ptexp <- pointcex*multiplevector

  if (length(mnstatsfiles) > 0) {
    firststats <- readmnstatsfile(mnstatsfiles[1])
    genomename <- assemblylabels[1]

    if (length(firststats$reflength) > 0) {
        plotdata <- mononucaccuracystats(firststats)
        mnlengths <- plotdata[seq(1,30), "lengths"]
        accuracies <- plotdata[seq(1,30), "accuracy"]
        accconfints <- binconf(plotdata[seq(1,30), "correctcalls"], plotdata[seq(1,30), "totals"], return.df=TRUE)
        lowaccs <- accconfints$Lower
        highaccs <- accconfints$Upper
        plot(mnlengths, accuracies, xlim=c(10,40), ylim=c(0.0,1.0), pch=pchvalues[1], cex=ptexp[1], col=assemblycolors[1], xlab=c("Mononucleotide run length"), ylab=c("Accuracy"), main=c("Accuracy of mononucleotide runs"))
        #text(20, 0.5, labels= paste(c("Overall error rate: ", mononucerrorperc, "%"), sep="", collapse=""))
        if (errorbars) {
          arrows(x0=mnlengths, y0=lowaccs, x1=mnlengths, y1=highaccs, code=3, angle=90, length=0.1, col=assemblycolors[1])
        }
     }
  }
  if (length(mnstatsfiles) > 1) {
    for (i in seq(2, length(mnstatsfiles))) {
      nextstats <- readmnstatsfile(mnstatsfiles[i])
      if (length(nextstats$reflength) > 0) {
          plotdata <- mononucaccuracystats(nextstats)
          mnlengths <- plotdata[seq(1,30), "lengths"]
          accuracies <- plotdata[seq(1,30), "accuracy"]
          accconfints <- binconf(plotdata[seq(1,30), "correctcalls"], plotdata[seq(1,30), "totals"], return.df=TRUE)
          lowaccs <- accconfints$Lower
          highaccs <- accconfints$Upper
          points(mnlengths, accuracies, xlim=c(10,40), cex=ptexp[i], pch=pchvalues[i], col=assemblycolors[i])
          if (errorbars) {
            arrows(x0=mnlengths, y0=lowaccs, x1=mnlengths, y1=highaccs, code=3, angle=90, length=0.1, col=assemblycolors[i])
          }
      }
    }
  }

  legend(legendxpos, legendypos, assemblylabels, bty="n", col=assemblycolors, pch=pchvalues, pt.cex=ptexp)
}

assembly_mononucqv_plot <- function(mnstatsfiles=c(), assemblylabels=c(), plottitle="", plotlines=FALSE, linetype=1, errorbars=FALSE, pointcex=1.0, overallerrorrate=NA) {
  pchvalues <- c(15, 16, 17, 18, 15, 16, 17, 18, 15, 16, 17, 18)
  multiplevector <- c(1.4, 1.4, 1.4, 1.9, 1.4, 1.4, 1.4, 1.9, 1.4, 1.4, 1.4, 1.9)
  ptexp <- pointcex*multiplevector

  if (length(mnstatsfiles) > 0) {
    firststats <- readmnstatsfile(mnstatsfiles[1])
    if (length(firststats$reflength) > 0) {
        genomename <- assemblylabels[1]
        plotdata <- mononucaccuracystats(firststats)
        mnlengths <- plotdata[seq(1,30), "lengths"]
        errorrates <- plotdata[seq(1,30), "errors"]/plotdata[seq(1,30), "totals"]
        errorconfints <- binconf(plotdata[seq(1,30), "errors"], plotdata[seq(1,30), "totals"], return.df=TRUE)
        lowqvals <- -10.0*log10(errorconfints$Lower)
        highqvals <- -10.0*log10(errorconfints$Upper)
    
        maxqv <- max(highqvals)
    
        qvals <- sapply(errorrates, function(x) { qv=-10.0*log10(x); return(qv) })
        if (plotlines) {
          plot(mnlengths, qvals, xlim=c(10,40), ylim=c(0, maxqv+1), type='l', lty=linetype, pch=pchvalues[1], col=assemblycolors[1], xlab=c("Mononucleotide run length"), ylab=c("Phred QV Score"), main=c("Accuracy of mononucleotide runs"))
        }
        else {
          plot(mnlengths, qvals, xlim=c(10,40), ylim=c(0, maxqv+1), pch=pchvalues[1], col=assemblycolors[1], xlab=c("Mononucleotide run length"), ylab=c("Phred QV Score"), main=c("Accuracy of mononucleotide runs"), cex=ptexp[1])
        }
        if (errorbars) {
          arrows(x0=mnlengths, y0=lowqvals, x1=mnlengths, y1=highqvals, code=3, angle=90, length=0, col=assemblycolors[1])
        }
    }
  }
  if (length(mnstatsfiles) > 1) {
    for (i in seq(2, length(mnstatsfiles))) {
      nextstats <- readmnstatsfile(mnstatsfiles[i])
      if (length(nextstats$reflength) > 0) {
          plotdata <- mononucaccuracystats(nextstats)
          mnlengths <- plotdata[seq(1,30), "lengths"]
          errorrates <- plotdata[seq(1,30), "errors"]/plotdata[seq(1,30), "totals"]
          errorconfints <- binconf(plotdata[seq(1,30), "errors"], plotdata[seq(1,30), "totals"], return.df=TRUE)
          lowqvals <- -10.0*log10(errorconfints$Lower)
          highqvals <- -10.0*log10(errorconfints$Upper)
    
          qvals <- sapply(errorrates, function(x) { qv=-10.0*log10(x); return(qv) })
          if (plotlines) {
            points(mnlengths, qvals, xlim=c(10,40), type='l', lty=linetype, pch=pchvalues[i], col=assemblycolors[i])
          }
          else {
            points(mnlengths, qvals, xlim=c(10,40), cex=ptexp[i], pch=pchvalues[i], col=assemblycolors[i])
          }
          if (errorbars) {
            arrows(x0=mnlengths, y0=lowqvals, x1=mnlengths, y1=highqvals, code=3, angle=90, length=0, col=assemblycolors[i])
          }
      }
    }
  }
  if (!is.na(overallerrorrate)) {
    text(30, maxqv-1, labels= paste(c("Overall error rate: ", overallerrorrate, "%"), sep="", collapse=""))
  }

  if (plotlines) {
    legend("topright", assemblylabels, bty="n", col=assemblycolors, lty=linetype)
  }
  else {
    legend("topright", assemblylabels, bty="n", col=assemblycolors, pch=pchvalues, pt.cex=pointcex*multiplevector)
  }
}

##### END Homopolymer Accuracy Curve Plotting Routines #####

##### START Indel Errors by Size Plotting Routines #####

plotindellengths <- function(indellengthfile, outputdir, xlabval="Length difference", ylabval="Indel Errors per mb", titleval="", ymax=NA) {
  indellengthhist <- read.table(indellengthfile, sep="\t", col.names=c("indellength", "indelcount", "indelspermbaligned"))
  
  insertionrates <- sapply(seq(1, 10), function(i) {if (any(indellengthhist$indellength==i)) {indellengthhist[indellengthhist$indellength==i, "indelspermbaligned"]} else {0}})
  deletionrates <- sapply(seq(1, 10), function(i) {if (any(indellengthhist$indellength==-1*i)) {indellengthhist[indellengthhist$indellength==-1*i, "indelspermbaligned"]} else {0}})

  insertioncolor <- methodcolors[1]
  deletioncolor <- methodcolors[2]

  if (is.na(ymax)) {
    barplot(rbind(deletionrates, insertionrates), beside=TRUE, names.arg=seq(1,10), col=c(insertioncolor, deletioncolor), main=titleval, xlab=xlabval, ylab=ylabval)
  }
  else {
    barplot(rbind(deletionrates, insertionrates), beside=TRUE, names.arg=seq(1,10), col=c(insertioncolor, deletioncolor), main=titleval, xlab=xlabval, ylab=ylabval, ylim=c(0,ymax))
  }
  legend("topright", c("Deletions", "Insertions"), col=c(insertioncolor, deletioncolor), pch=15)
}

##### END Indel Errors by Size Plotting Routines #####

##### START SNV and Indel Errors Plotting Routines #####

# Routines for plotting substitution rate-by-type histogram:

typeorder <- c("A_C", "A_G", "A_T", "T_C", "T_G", "T_A", "G_A", "G_T", "G_C", "C_A", "C_T", "C_G")
titv <- c("tv", "ti", "tv", "ti", "tv", "tv", "ti", "tv", "tv", "tv", "ti", "tv" )

cnvrt.coords <-function(x,y=NULL){
  xy <- xy.coords(x, y, recycle=TRUE)
  cusr <- par('usr')
  cplt <- par('plt')  
  plt <- list()
  plt$x <- (xy$x-cusr[1])/(cusr[2]-cusr[1])
  plt$y <- (xy$y-cusr[3])/(cusr[4]-cusr[3])
  fig <- list()
  fig$x <- plt$x*(cplt[2]-cplt[1])+cplt[1]
  fig$y <- plt$y*(cplt[4]-cplt[3])+cplt[3]
  return( list(fig=fig) )
}

plotpartialbarplot <- function(fn, x, y=NULL, barpositions=c(), barlabels=c()){
  old.par <- par(no.readonly=TRUE)
  on.exit(par(old.par))
  xy <- xy.coords(x, y)
  xy <- cnvrt.coords(xy)$fig
  par(plt=c(xy$x,xy$y), new=TRUE)
  output <- fn
  #text(output, barpositions, barlabels, pos=3, xpd=NA)
  tmp.par <- par(no.readonly=TRUE)
  return(invisible(tmp.par))
}

assembly_substitutions_plot <- function(assemblysubsfiles, assemblylabels, xlabval="Assembly", ylabval="Substitutions per mb", ybreak=c(0,0), titleval="", ymax=NA, legendypos=160.0, legend=TRUE, spanmax=21, spanbreak=c(10, 13)) {
  
  # note that the GQC "singlenucerrorstats.txt" output file does *not* include phasing errors (errors that match the opposite haplotype allele), only consensus
  firsthist <- read.table(assemblysubsfiles[1], sep="\t", col.names=c("errortype", "errorcount", "errorspermbaligned"))
  typeorderindex <- sapply(firsthist$errortype, function(x) {which(typeorder==x)})
  if (length(firsthist$errortype) > 0) {
      firsttis <- sum(firsthist[titv[typeorderindex]=="ti", "errorspermbaligned"])
      firsttvs <- sum(firsthist[titv[typeorderindex]=="tv", "errorspermbaligned"])
      tivals <- c(firsttis)
      tvvals <- c(firsttvs)
  }
  else {
      tivals <- c(0)
      tvvals <- c(0)
  }
  assemblylabelswithtitv <- sapply(assemblylabels, function(x) {label = paste(c("Ti     Tv\n", x), sep="", collapse=""); return(label)})
 
  if (length(assemblysubsfiles) > 1) {
    for (i in seq(2, length(assemblysubsfiles))) {
      subshist <- read.table(assemblysubsfiles[i], sep="\t", col.names=c("errortype", "errorcount", "errorspermbaligned"))
      typeorderindex <- sapply(subshist$errortype, function(x) {which(typeorder==x)})

      if (length(subshist$errortype) > 0) {
          assemblytis <- sum(subshist[titv[typeorderindex]=="ti", "errorspermbaligned"])
          assemblytvs <- sum(subshist[titv[typeorderindex]=="tv", "errorspermbaligned"])
      }
      else {
	  assemblytis <- 0
          assemblytvs <- 0
      }      
      
      tivals <- append(tivals, assemblytis)
      tvvals <- append(tvvals, assemblytvs)
    }
  }
    
  barcolors <- sapply(assemblycolors, function(x) {c(darken(x), lighten(x, 0.3))})
    
  if (ybreak[1] > 0) {
    lowspan <- c(0, spanbreak[1])
    highspan <- c(spanbreak[2], spanmax)
    plot(c(0,1), c(0,21), type='n', axes=FALSE, xlab="", ylab=ylabval, lwd=7)
    formattedrates <- as.integer(rbind(tivals, tvvals)*10+0.5)/10
    labelpositions <- rbind(tivals, tvvals)
      
    out <- plotpartialbarplot(barplot(rbind(tivals, tvvals), names.arg=assemblylabelswithtitv, beside=TRUE, col=barcolors, xlab=xlabval, ylim=c(0, ybreak[1]), xpd=FALSE), x=c(0,1), y=lowspan, barpositions=labelpositions, barlabels=formattedrates)
    par(new=TRUE)
    plotpartialbarplot(barplot(rbind(tivals, tvvals), beside=TRUE, col=barcolors, ylim=c(ybreak[2], ymax), main=titleval, xpd=FALSE, names.arg=vector(mode="character", length=length(rbind(tivals, tvvals)))), x=c(0,1), y=highspan, barpositions=labelpositions, barlabels=formattedrates)
    lowertop=lowspan[2]+1
    breakheight=1.0
    upperbottom=lowertop + breakheight
    # Make the diagonal break markers
    markerheight=0.4
    markerwidth=0.04
    lines(c(0, 0), c(1, lowertop))
    lines(c(markerwidth/-2, markerwidth/2), c(lowertop-markerheight/2, lowertop+markerheight/2))
    lines(c(0, 0),c(upperbottom, 14))
    lines(c(markerwidth/-2, markerwidth/2), c(upperbottom-markerheight/2, upperbottom+markerheight/2))
    if (legend) {
      legend("topright", assemblylabels, col=assemblycolors, pch=15)
    }
    return(formattedrates)
  }
  else if (is.na(ymax)) {
    out <- barplot(rbind(tivals, tvvals), names.arg=assemblylabelswithtitv, beside=TRUE, col=barcolors, main=titleval, xlab=xlabval, ylab=ylabval)
  }
  else {
    out <- barplot(rbind(tivals, tvvals), names.arg=assemblylabelswithtitv, beside=TRUE, col=typecolors, main=titleval, xlab=xlabval, ylab=ylabval, ylim=c(0,ymax))
  }
  
  if (legend) {
    legend(out[5], legendypos, assemblylabels, col=assemblycolors, pch=15)
  }
  formattedrates <- as.integer(rbind(tivals, tvvals)*10+0.5)/10
  text(out, rbind(tivals, tvvals), formattedrates, pos=3, xpd=NA)
  return(out)
}

# Routines for plotting indel rates:

totalindelrate <- function(indellengthfile) {
  indellengthhist <- read.table(indellengthfile, sep="\t", col.names=c("indellength", "indelcount", "indelspermbaligned"))
  
  return(sum(indellengthhist$indelspermbaligned, na.rm=TRUE))  
}
totalinsertionrate <- function(indellengthfile) {
  indellengthhist <- read.table(indellengthfile, sep="\t", col.names=c("indellength", "indelcount", "indelspermbaligned"))
  
  return(sum(indellengthhist[indellengthhist$indellength>0, "indelspermbaligned"], na.rm=TRUE))  
}
totaldeletionrate <- function(indellengthfile) {
  indellengthhist <- read.table(indellengthfile, sep="\t", col.names=c("indellength", "indelcount", "indelspermbaligned"))
  
  return(sum(indellengthhist[indellengthhist$indellength<0, "indelspermbaligned"], na.rm=TRUE))  
}

assembly_indels_plot <- function(indellengthfiles, assemblylabels, xlabval="Assembly", ylabval="Indel Errors per mb", legendypos=25.0, titleval="", ymax=NA) {
  totalinsertionrates <- sapply(indellengthfiles, totalinsertionrate)
  totaldeletionrates <- sapply(indellengthfiles, totaldeletionrate)
  
  assemblylabelswithinsdel <- sapply(assemblylabels, function(x) {label = paste(c("Del     Ins\n", x), sep="", collapse=""); return(label)})
  
  barcolors <- sapply(assemblycolors, function(x) {c(darken(x), lighten(x, 0.3))})
  out <- barplot(rbind(totaldeletionrates, totalinsertionrates), beside=TRUE, names.arg=assemblylabelswithinsdel, col=barcolors, main=titleval, xlab=xlabval, ylab=ylabval)
  legend(out[5], legendypos, assemblylabels, col=assemblycolors, pch=15)
  formattedrates <- as.integer(rbind(totaldeletionrates, totalinsertionrates)*10+0.5)/10
  text(out, rbind(totaldeletionrates, totalinsertionrates), formattedrates, pos=3, xpd=NA)
  
}

assembly_compound_plot <- function(assemblysubsfile, indellengthfile, assemblyname, ylabval="Indels or Substitutions per mb", titleval="", ymax=NA, assemblyqv=NA) {
  
  # note that the GQC "singlenucerrorstats.txt" output file does *not* include phasing errors, only consensus
  firsthist <- read.table(assemblysubsfile, sep="\t", col.names=c("errortype", "errorcount", "errorspermbaligned"))
  typeorderindex <- sapply(firsthist$errortype, function(x) {which(typeorder==x)})
  if (length(firsthist$errortype) > 0) {
     firsttis <- sum(firsthist[titv[typeorderindex]=="ti", "errorspermbaligned"])
     firsttvs <- sum(firsthist[titv[typeorderindex]=="tv", "errorspermbaligned"])
  }
  else {
     firsttis <- 0
     firsttvs <- 0
  }
  leftvals <- c(firsttis)
  rightvals <- c(firsttvs)
  assemblylabelwithtitv <- paste(c("Ti     Tv\n", "Substitutions"), sep="", collapse="")
  assemblylabelwithinsdel <- paste(c("Del     Ins\n", "Indels"), sep="", collapse="")

  leftvals <- append(leftvals, totaldeletionrate(indellengthfile))
  rightvals <- append(rightvals, totalinsertionrate(indellengthfile))
 
  barcolors <- sapply(assemblycolors[1], function(x) {c(darken(x), lighten(x, 0.3))})
  
  if (is.na(ymax)) {
    out <- barplot(rbind(leftvals, rightvals), names.arg=c(assemblylabelwithtitv, assemblylabelwithinsdel), beside=TRUE, col=c(barcolors, barcolors), main=titleval, ylab=ylabval)
  }
  else {
    out <- barplot(rbind(leftvals, rightvals), names.arg=c(assemblylabelswithtitv, assemblylabelwithinsdel), beside=TRUE, col=c(barcolors, barcolors), main=titleval, ylab=ylabval, ylim=c(0,ymax))
  }

  formattedrates <- as.integer(rbind(leftvals, rightvals)*10+0.5)/10
  labelpositions <- rbind(leftvals, rightvals)
  
  text(out, labelpositions, formattedrates, pos=3, xpd=NA)

  if (!is.na(assemblyqv)) {
      qvlabel <- paste(c("Assembly QV: ", assemblyqv), sep="", collapse="")
      text(2, (leftvals[1]+leftvals[2])/2, qvlabel)
  }
}

assembly_switchrate_plot <- function(assemblynames, assemblylabels, switchfile=phaseswitchfile, plottitle="Phase switch errors per megabase") {
  switchrates <- read.table(switchfile, sep="\t", header=FALSE)
  names(switchrates) <- c("Assembly", "SwitchRate")

  # bottom, left, top, right  
  defaultmargin <- c(5.1, 4.1, 4.1, 2.1)
  par(mar = c(5.1, 9.1, 4.1, 4.1))
  #par(mar = c(5.1, 10.1, 4.1, 4.1))
  options(scipen=8)

  assemblyswitchrates <- sapply(assemblynames, function(x) {switchrates[switchrates$Assembly==x, "SwitchRate"]})

  out <- barplot(rev(log10(as.numeric(assemblyswitchrates))), names.arg=rev(assemblylabels), las=1, horiz=TRUE, xaxt='n', col=rev(assemblycolors[1:length(assemblynames)]), xlab=c("Errors per megabase"), main=plottitle)
  xval <- c(1, 10, 100, 1000)
  xpos <- log10(xval)
  axis(1, xpos, xval, las=1)
  formattedrates <- as.integer(assemblyswitchrates*10+0.5)/10
  text(log10(rev(assemblyswitchrates)), out, rev(formattedrates), pos=4, xpd=NA)
  par(mar=defaultmargin)

}

# Routines for plotting sideways barplot of switch rates

assembly_missingness_plot <- function(assemblynames, assemblylabels, missingnessfile=missingfile, plottitle="Uncovered HG002v1.1 bases") {
  missingbases <- read.table(missingfile, sep="\t", header=FALSE)
  names(missingbases) <- c("Assembly", "MissingBases")

  # bottom, left, top, right  
  defaultmargin <- c(5.1, 4.1, 4.1, 2.1)
  par(mar = c(5.1, 9.1, 4.1, 4.1))
  #par(mar = c(5.1, 10.1, 4.1, 4.1))
  options(scipen=8)

  assemblymissingrates <- sapply(assemblynames, function(x) {missingbases[missingbases$Assembly==x, "MissingBases"]})
  assemblymissingrates <- assemblymissingrates/1000000

  out <- barplot(rev(log10(as.numeric(assemblymissingrates))), names.arg=rev(assemblylabels), las=1, horiz=TRUE, xaxt='n', col=rev(assemblycolors[1:length(assemblynames)]), xlab=c("Missing bases (Mb)"), main=plottitle)
  xval <- c(1, 10, 100, 1000)
  xpos <- log10(xval)
  axis(1, xpos, xval, las=1)
  formattedrates <- as.integer(assemblymissingrates*10+0.5)/10
  text(log10(rev(assemblymissingrates)), out, rev(formattedrates), pos=4, xpd=NA)
  par(mar=defaultmargin)

  return(assemblymissingrates)
}

# Routines for plotting quality values:

assembly_qv_plot <-function(assembly_stats_file, yak_stats_file, merq_stats_file, assemblynames, assemblylabels, titleval="Assembly QV by different methods", noyak=TRUE) {

  assembly_qv_stats <- read.table(assembly_stats_file, sep="\t", header=FALSE)
  names(assembly_qv_stats) <- c("Assembly", "QV")

  if (!(noyak)) {
    yak_qv_stats <- read.table(yak_stats_file, sep="\t", header=FALSE)
    names(yak_qv_stats) <- c("Assembly", "ErrorCount", "AssemblyCount", "QV", "Unused", "AssemblyFile")
  }

  merq_qv_stats <- read.table(merq_stats_file, sep="\t", header=FALSE)
  names(merq_qv_stats) <- c("Assembly", "ErrorCount", "AssemblyCount", "QV", "Unused")

  qvs_to_map <- data.frame("assembly"=assemblynames)
  qvs_to_map$assemblyqv <- sapply(assemblynames, function(x) {assembly_qv_stats[assembly_qv_stats$Assembly==x, "QV"]})
  if (!(noyak)) {
    qvs_to_map$yakqv <- sapply(assemblynames, function(x) {yak_qv_stats[yak_qv_stats$Assembly==x, "QV"]})
  }
  qvs_to_map$merqqv <- sapply(assemblynames, function(x) {merq_qv_stats[merq_qv_stats$Assembly==x, "QV"]})
  benchmarkmerq <- merq_qv_stats[merq_qv_stats$Assembly=="hg002v1.1", "QV"]

  #return(qvs_to_map)
  if (!(noyak)) {
    minqv <- min(rbind(qvs_to_map$assemblyqv, qvs_to_map$yakqv, qvs_to_map$merqqv), na.rm=TRUE)
    maxqv <- max(rbind(qvs_to_map$assemblyqv, qvs_to_map$yakqv, qvs_to_map$merqqv), na.rm=TRUE)
    if (maxqv<benchmarkmerq) {
      maxqv <- benchmarkmerq + 10
    }
    barplot(t(cbind(qvs_to_map$yakqv, qvs_to_map$merqqv, qvs_to_map$assemblyqv)), beside=TRUE, names.arg=assemblylabels, cex.names=0.7, col=qvmethodcolors, xlab="Assembly", ylim=c(0, maxqv+20), main=titleval)
    abline(h=benchmarkmerq, lty=3)
    text(5, benchmarkmerq, "HG002v1.1 Merqury", pos=2)
    legend("topright", c("Yak", "Merqury", "GQC Benchmark"), col=qvmethodcolors, pch=15)
  } else {
    barplotmethodcolors <- qvmethodcolors[2:3]
    minqv <- min(rbind(qvs_to_map$assemblyqv, qvs_to_map$merqqv), na.rm=TRUE)
    maxqv <- max(rbind(qvs_to_map$assemblyqv, qvs_to_map$merqqv), na.rm=TRUE)
    if (maxqv<benchmarkmerq) {
      maxqv <- benchmarkmerq + 10
    }
    barplot(t(cbind(qvs_to_map$yakqv, qvs_to_map$merqqv, qvs_to_map$assemblyqv)), beside=TRUE, names.arg=assemblylabels, cex.names=0.7, col=barplotmethodcolors, xlab="Assembly", ylim=c(0, maxqv+20), main=titleval)
    abline(h=benchmarkmerq, lty=3)
    text(5, benchmarkmerq, "HG002v1.1 Merqury", pos=2)
    legend("topright", c("Merqury", "GQC Benchmark"), bty="n", col=barplotmethodcolors, pch=15)
  }
}

#setwd("/Users/nhansen/OneDrive/HG002_diploid_benchmark/plots/ngaplots")

#source ("./AssemblyFunctions.R")

args = commandArgs(trailingOnly=TRUE)
assemblycolors <- c("#44AA99", "#332288", "#882255", "#888888", "#DDCC77", "#661100", "#6699CC")
methodcolors <- c("#DDCC77", "#661100", "#6699CC")

assemblyname <- ifelse(!( is.na(args[1])), args[1], "lc24_ul_herro_ulk")
genomename <- ifelse(!( is.na(args[2])), args[2], "v1.1")
outputdir <- ifelse(!( is.na(args[3])), args[3], ".")
idealfile <- ifelse(!( is.na(args[4])), args[4], "v1.1.non_n_seq.bed")
plottitle <- ifelse(!( is.na(args[5])), args[5], paste(c("NGAx ", assemblyname, " vs ", genomename), sep="", collapse=""))
lengthtypes <- c("alignclusterlengths", "contiglengths", "scaffoldlengths")
assemblysizefiles <- sapply(lengthtypes, function(x) {file=paste(c(outputdir, "/", assemblyname, ".", x, ".txt"), sep="", collapse=""); return(file)})

# Make NGAx plot:
plotname <- paste(c(outputdir, "/", assemblyname, ".continuitystats.", genomename, ".pdf"), sep="", collapse="")
pdf(plotname)
assembly_ngax_plot(assemblysizefiles, assemblylabels=c("Aligned NGAx", "Contig NGx", "Scaffold NGx"), ideal=TRUE, idealname=genomename, haplotype=NA, plottitle=paste(c("Continuity stats for ", assemblyname), sep="", col=""))
dev.off()

library(stringr)
args = commandArgs(trailingOnly=TRUE)

assemblyname <- ifelse(!( is.na(args[1])), args[1], "illumina2x250mat")
genomename <- ifelse(!( is.na(args[2])), args[2], "v1.1")
outputdir <- ifelse(!( is.na(args[3])), args[3], ".")
idealfile <- ifelse(!( is.na(args[4])), args[4], "v1.1.non_n_seq.bed")
assemblyqv <- ifelse(!( is.na(args[5])), args[5], NA)

indelfile <- paste(c(outputdir, "/", assemblyname, ".indelerrorstats.txt"), sep="", collapse="")
subsfile <- paste(c(outputdir, "/", assemblyname, ".singlenucerrorstats.txt"), sep="", collapse="")
plotname <- paste(c(outputdir, "/", assemblyname, ".summarystats.", genomename, ".pdf"), sep="", collapse="")

#plottitle <- ifelse(!( is.na(args[5])), args[5], paste(c("NGAx ", assemblyname, " vs ", genomename), sep="", collapse=""))
lengthtypes <- c("alignclusterlengths", "contiglengths", "scaffoldlengths")
assemblysizefiles <- sapply(lengthtypes, function(x) {file=paste(c(outputdir, "/", assemblyname, ".", x, ".txt"), sep="", collapse=""); return(file)})

mononucsitefile <- paste(c(outputdir, "/", assemblyname, ".mononucstats.txt"), sep="", collapse="")
mononucsites <- read.table(mononucsitefile, header=FALSE, sep="\t", col.names=c("name", "base", "reflength", "assemblylength", "type"))

consensuserrors <- mononucsites[(mononucsites$assemblylength != -1) & (mononucsites$type == "CONSENSUS") & (mononucsites$reflength < 100) & (mononucsites$reflength >= 10), ]
noncomplexcovered <- mononucsites[(mononucsites$assemblylength != -1) & (mononucsites$reflength < 100) & (mononucsites$reflength >= 10), ]

# Make summary plot:
pdf(plotname, 11.0, 11.0)
par(mfrow=c(2,2))
assembly_ngax_plot(assemblysizefiles, assemblylabels=c("Aligned NGAx", "Contig NGx", "Scaffold NGx"), ideal=TRUE, idealname=genomename, haplotype=NA, plottitle=paste(c("Continuity stats for ", assemblyname), sep="", collapse=""))

if (length(noncomplexcovered$name) > 0) {
    mononucerrorrate <- length(consensuserrors$reflength)/length(noncomplexcovered$reflength)
    mononucerrorperc <- round(mononucerrorrate*100, 2)

    # Calculate error rate as consensus error counts divided by covered counts that aren't complex:
    
    consensuserrorcounts <- hist(consensuserrors$reflength, plot=FALSE, breaks=seq(10, 100, 1))
    noncomplexcovcounts <- hist(noncomplexcovered$reflength, plot=FALSE, breaks=seq(10, 100, 1))
    
    accrate <- 1.0 - consensuserrorcounts$counts/noncomplexcovcounts$counts
    assembly_mononucqv_plot(c(mononucsitefile), assemblylabels=c(genomename), plottitle="", plotlines=TRUE, linetype=1, errorbars=TRUE, overallerrorrate=mononucerrorperc)
}
assembly_compound_plot(subsfile, indelfile, readsetname, titleval=paste(c(assemblyname, " Discrepancy Counts"), sep="", collapse=""), assemblyqv=assemblyqv)
plotindellengths(indelfile, outputdir, titleval=paste(c("Indel rate by length for ", assemblyname), sep="", collapse=""))
dev.off()

# Next two lines are for testing--comment out for distribution
#setwd("/Users/nhansen/GQC/devtests/multiplots")
#source("/Users/nhansen/GQC/github/GQC/GQC/AssemblyComparisonPlotFunctions.R")

library(colorspace)
library(Hmisc)
library(plotrix)

args = commandArgs(trailingOnly=TRUE)

assemblyfile <- ifelse(!( is.na(args[1])), args[1], "testassemblies.txt")
benchname <- ifelse(!( is.na(args[2])), args[2], "v1.1")
outputdir <- ifelse(!( is.na(args[3])), args[3], ".")
idealfile <- ifelse(!( is.na(args[4])), args[4], "hg002v1.1.alignclusterlengths.txt")

safe_colorblind_palette <- c("#88CCEE", "#CC6677", "#DDCC77", "#117733", "#332288", "#AA4499", 
                             "#44AA99", "#999933", "#882255", "#661100", "#6699CC", "#888888")
assemblycolors <- c("#44AA99", "#332288", "#882255", "#888888", "#661100","#999933","#88CCEE", "#CC6677", "#DDCC77")
qvmethodcolors <- c("#DDCC77", "#661100", "#6699CC")

assemblydf <- read.table(assemblyfile, sep="\t", comment.char="$")
assemblydirs <- assemblydf$V1
assemblyprefixes <- assemblydf$V2
assemblylabels <- assemblydf$V3
shortassemblylabels <- assemblydf$V4

if (length(assemblydf)>4) {
  assemblycolors <- assemblydf$V5
}

scaffoldsizefiles <- sapply(seq(1, length(assemblydirs)), function(x) {file=paste(c(assemblydirs[x], "/", assemblyprefixes[x], ".alignclusterlengths.txt"), sep="", collapse=""); return(file)})
mnstatsfiles <- sapply(seq(1, length(assemblydirs)), function(x) {file=paste(c(assemblydirs[x], "/", assemblyprefixes[x], ".mononucstats.txt"), sep="", collapse=""); return(file)})
substitutionstatsfiles <- sapply(seq(1, length(assemblydirs)), function(x) {file=paste(c(assemblydirs[x], "/", assemblyprefixes[x], ".singlenucerrorstats.txt"), sep="", collapse=""); return(file)})
indelstatsfiles <- sapply(seq(1, length(assemblydirs)), function(x) {file=paste(c(assemblydirs[x], "/", assemblyprefixes[x], ".indelerrorstats.txt"), sep="", collapse=""); return(file)})

pdf("NGAx.pdf", width=7, height=7)
assembly_ngax_plot(scaffoldsizefiles, assemblylabels=assemblylabels, ideal=TRUE, idealname=benchname, aung=FALSE, plottitle="NGAx for different assemblies", idealfile=idealfile)
dev.off()
pdf("SubstitutionRates.pdf", width=7, height=7)
assembly_substitutions_plot(substitutionstatsfiles, assemblylabels=assemblylabels, legendypos=150, titleval="Substitution discrepancies in assemblies")
dev.off()
pdf("IndelRates.pdf", width=7, height=7)
assembly_indels_plot(indelstatsfiles, shortassemblylabels, titleval="Indel discrepancy rates in assemblies", legendypos=20.0)
dev.off()
pdf("HomopolymerRuns.pdf", width=7, height=7)
assembly_mononucqv_plot(mnstatsfiles, assemblylabels, errorbars=TRUE, pointcex=0, plotlines=TRUE, linetype=2)
dev.off()

pdf("SummaryStatsPlots.pdf", width=10, height=10)
par(mfrow=c(2,2))
assembly_ngax_plot(scaffoldsizefiles, assemblylabels=assemblylabels, ideal=TRUE, idealname=benchname, aung=FALSE, plottitle="NGAx for different assemblies", idealfile=idealfile)
assembly_substitutions_plot(substitutionstatsfiles, assemblylabels=assemblylabels, legendypos=150, titleval="Substitution discrepancies in assemblies")
assembly_indels_plot(indelstatsfiles, shortassemblylabels, titleval="Indel discrepancy rates in assemblies", legendypos=20.0)
assembly_mononucqv_plot(mnstatsfiles, assemblylabels, errorbars=TRUE, pointcex=0, plotlines=TRUE, linetype=2)
dev.off()

library(stringr)

#setwd("/Users/nhansen/OneDrive/HPRC_assembly_comparison/data_for_Rplots/alignplots")
args = commandArgs(trailingOnly=TRUE)

pardefault <- par()

chromfile <- ifelse(!( is.na(args[1])), args[1], "clustered_aligns.chr1_MATERNAL.clusters.bed")
genomename <- ifelse(!( is.na(args[2])), args[2], "year1pat")
benchname <- ifelse(!( is.na(args[3])), args[3], "v1.0.1")
outputdir <- ifelse(!( is.na(args[4])), args[4], ".")
chromlength <- ifelse(! ( is.na(args[5])), as.integer(args[5]), NA)
refgapfile <- ifelse(! ( is.na(args[6])), args[6], NA)
querygapfile <- ifelse(! ( is.na(args[7])), args[7], NA)
vertline <- ifelse(! ( is.na(args[8])), as.integer(args[8]), NA)

# plot positions in megabases:
axisunitbases <- 1000000
safe_colorblind_palette <- c("#332288", "#88CCEE", "#CC6677", "#DDCC77", "#117733", "#AA4499", 
                             "#44AA99", "#999933", "#882255", "#661100", "#6699CC", "#888888")

readaligns <- function(chromfile) {
  aligns <- read.table(chromfile, sep="\t", header=FALSE, comment.char="!")
  names(aligns) <- c("chrom", "start", "end", "alignname")

  aligns$start <- as.numeric(aligns$start)/axisunitbases
  aligns$end <- as.numeric(aligns$end)/axisunitbases
  aligns$query <- sapply(seq(1, length(aligns$alignname)), function(i) {us_fields <- strsplit(aligns$alignname, split="_"); return(paste(us_fields[[i]][1:(length(us_fields[[i]])-3)], sep="_", collapse="_"))})
  aligns$querystart <- sapply(seq(1, length(aligns$alignname)), function(i) {us_fields <- strsplit(aligns$alignname, split="_"); return(as.numeric(us_fields[[i]][length(us_fields[[i]]) - 2])/axisunitbases)})
  aligns$queryend <- sapply(seq(1, length(aligns$alignname)), function(i) {us_fields <- strsplit(aligns$alignname, split="_"); return(as.numeric(us_fields[[i]][length(us_fields[[i]]) - 1])/axisunitbases)})
  aligns$cluster <- sapply(seq(1, length(aligns$alignname)), function(i) {us_fields <- strsplit(aligns$alignname, split="_"); return(us_fields[[i]][length(us_fields[[i]])])})

  chromorderedaligns <- aligns[order(aligns$start, aligns$end), ]
  
  return(chromorderedaligns)
}

minpos <- function(aligns, contigname) {
  startsends <- c(aligns[aligns$query==contigname, "querystart"], aligns[aligns$query==contigname, "queryend"])
  return(min(startsends))
}

maxpos <- function(aligns, contigname) {
  startsends <- c(aligns[aligns$query==contigname, "querystart"], aligns[aligns$query==contigname, "queryend"])
  return(max(startsends))
}

minrefpos <- function(aligns, contigname) {
  startsends <- c(aligns[aligns$query==contigname, "start"], aligns[aligns$query==contigname, "end"])
  return(min(startsends))
}

maxrefpos <- function(aligns, contigname) {
  startsends <- c(aligns[aligns$query==contigname, "start"], aligns[aligns$query==contigname, "end"])
  return(max(startsends))
}

contiginfo <- function(aligns) {
  
  ctginfo <- data.frame("contigname"=unique(aligns$query))
  ctginfo$minpos <- sapply(ctginfo$contigname, function(x) {minpos(aligns, x)})
  ctginfo$maxpos <- sapply(ctginfo$contigname, function(x) {maxpos(aligns, x)})
  ctginfo$minrefpos <- sapply(ctginfo$contigname, function(x) {minrefpos(aligns, x)})
  ctginfo$maxrefpos <- sapply(ctginfo$contigname, function(x) {maxrefpos(aligns, x)})
  ctginfo$basescovered <- ctginfo$maxpos - ctginfo$minpos
  
  return(ctginfo)
}


orderedcontigs <- function(aligns) {
  ctginfo <- contiginfo(aligns) 
  orderedctginfo <- ctginfo[order(ctginfo$minrefpos, decreasing = FALSE), ]
  
  return(orderedctginfo)
}

plotaligns <- function(aligns, index=1, suppressaxis=FALSE, suppresstitle=FALSE, suppressxunits=FALSE, chrommin=NA, chrommax=NA, querymin=NA, querymax=NA, vertline=NA, vertlinelabel=NA, refgaps=NA, querygaps=NA) {
  ctginfo <- contiginfo(aligns)
  orderedctginfo <- orderedcontigs(aligns)

  chrom <- aligns[1, "chrom"]
  if(is.na(chrommin)) {
    chrommin <- min(aligns$start)
  }
  if(is.na(chrommax)) {
    chrommax <- max(aligns$end)
  }

  bigcontig <- orderedctginfo[index, "contigname"]
  bigcontigaligns <- aligns[aligns$query==bigcontig, ]

  if (is.na(querymin)) {
    querymin <- ctginfo[ctginfo$contigname==bigcontig, "minpos"]
  }  
  if (is.na(querymax)) {
    querymax <- ctginfo[ctginfo$contigname==bigcontig, "maxpos"]
  }  
  
  contigclusters <- unique(bigcontigaligns$cluster)
  nonsmallcontigclusters <- contigclusters[!str_detect(contigclusters, "Small")]
  
  clusterpalette <- safe_colorblind_palette[1:length(nonsmallcontigclusters)]
  
  alignclustercolors <- sapply(bigcontigaligns$cluster, function(x) {
    ifelse(str_detect(x, "Small"), "black", clusterpalette[which(nonsmallcontigclusters==x, arr.ind=TRUE)] )
    })
  orderedclusters <- contigclusters[order(contigclusters)]
  legendclustercolors <- sapply(orderedclusters, function(x) {
    ifelse(str_detect(x, "Small"), "black", clusterpalette[which(nonsmallcontigclusters==x, arr.ind=TRUE)] )
    })
  
  plottitle <- ifelse(suppresstitle, "", paste("Alignments of ", genomename, " to ", benchname))
  xaxtval <- ifelse(suppressxunits, "n", "s")
  xlabval <- ifelse(suppressxunits, "", chrom)
  plot(list(), list(), main=plottitle, xaxs='i', xaxt=xaxtval, xlab=xlabval, yaxs='i', ylab=orderedctginfo[index, "contigname"], 
       xlim=c(chrommin, chrommax), ylim=c(querymin, querymax))
  #plot(list(), list(), main=plottitle, xaxt=xaxtval, xlab=xlabval, ylab=orderedctginfo[index, "contigname"], 
       #xlim=c(chrommin, chrommax), ylim=c(querymin, querymax))
  

  segments(x0=bigcontigaligns$start, y0=bigcontigaligns$querystart, x1=bigcontigaligns$end, y1=bigcontigaligns$queryend, col=alignclustercolors)
  if (!(is.na(vertline))) {
    abline(v=vertline, lty=4)
    if (!is.na(vertlinelabel)) {
      text(vertline+2, 1, labels= vertlinelabel)
    }
  }
  if (length(refgaps) > 1 || !(is.na(refgaps))) {
    refstarts <- refgaps[refgaps$contig==chrom, "start"]/axisunitbases
    refends <- refgaps[refgaps$contig==chrom, "end"]/axisunitbases
    if (length(refstarts) > 0) {
      rect(refstarts, querymin, refends, querymax, col="gray")
    }
  }
  else {
    refstarts <- NA
    refends <- NA
  }

  if (length(querygaps)>1 || !(is.na(querygaps))) {
    querystarts <- querygaps[querygaps$contig==chrom, "start"]/axisunitbases
    queryends <- querygaps[querygaps$contig==chrom, "end"]/axisunitbases
    if (length(querystarts) > 0) {
      rect(chrommin, querystarts, chrommax, queryends, col="gray")
    }
  }
  else {
    querystarts <- NA
    queryends <- NA
  }

  legend("bottomright", orderedclusters, pch=15, col=legendclustercolors)
}


multiplotaligns <- function(aligns, chromlength=NA, chromplotfile=NA, plotheights=c(), minfrac=0.5, refgapfile=NA, querygapfile=NA, yqhstart=NA) {
  # query dataframe has only the contig names for contigs in the large clusters of alignments:
  querydf <- data.frame(query=unique(aligns[!str_detect(aligns$cluster, "Small"), "query"]))
  # querybasescovered is the total aligned bases in each contig (including those aligned within small clusters)
  querydf$querybasescovered <-sapply(querydf$query, function(x) {querycoverage(aligns, x)})
  querydf$refbasescovered <-sapply(querydf$query, function(x) {refcoverage(aligns, x)})
  querydf$minrefpos <-sapply(querydf$query, function(x) {minrefpos(aligns, x)})
  
  # don't bother to plot any alignments when aligned query bases are less than minfrac (0.5) of the ref chrom length:
  coveredbases <- sum(querydf$querybasescovered)
  halfchromlength <- 0.5*chromlength/axisunitbases

  if (coveredbases < halfchromlength) {
    return(0)
  }

  # open the file to plot to if there is one:
  if (!is.na(chromplotfile)) {
    pdf(chromplotfile, 8.5, 8.5)
  }

  # if yqhstart is set, plot the start of the Yqh region  
  if (!is.na(yqhstart)) {
    yqhstart <- yqhstart/axisunitbases
  }
  
  # read in gaps if there are gap files:
  refgaps <- gaplocs(refgapfile)
  querygaps <- gaplocs(querygapfile)

  par(pardefault)
  numplots <- min(length(querydf$query), 4)

  # if just one contig aligns, no need for a matrix layout:
  if (numplots==1) {
    par(mfrow = c(1, 1))
    plotaligns(aligns, 1, chrommin=0, chrommax=floor(chromlength/axisunitbases+1), vertline=yqhstart, refgaps=refgaps, querygaps=querygaps)
  }
  else {
    sizeorderedquerydf <- querydf[order(querydf$refbasescovered, decreasing=TRUE), ]
    largestsize <- sizeorderedquerydf[1, "refbasescovered"]
    smallestsize <- sizeorderedquerydf[length(sizeorderedquerydf$refbasescovered), "refbasescovered"]
    
    sizefactor <- largestsize/50.0

    orderedquerydf <- querydf[order(querydf$minrefpos, decreasing=FALSE), ]
    if (length(plotheights)==0) {
      plotheights <- ifelse(as.integer(orderedquerydf$refbasescovered/sizefactor)>=1, as.integer(orderedquerydf$refbasescovered/sizefactor), 1)
      plotheights[length(plotheights)] <- plotheights[length(plotheights)] + 20
    }

    par(mfrow=c(numplots, 1))
    par(oma=c(4,1,3,1))
    nf <- layout(matrix(seq(1, numplots),ncol=1), widths=rep(80, numplots), heights=plotheights, TRUE)
    
    par(mar=c(0,4,2,1))
    plotaligns(aligns, 1, suppressaxis=TRUE, chrommin=0, chrommax=floor(chromlength/axisunitbases+1), suppressxunits=TRUE, vertline=yqhstart, refgaps=refgaps, querygaps=querygaps)
    if (numplots >= 3) {
       for (plotno in seq(2, numplots-1)) {
         par(mar=c(0,4,0,1))
         plotaligns(aligns, plotno, suppressaxis=TRUE, suppressxunits=TRUE, suppresstitle=TRUE, chrommin=0, chrommax=floor(chromlength/axisunitbases+1), vertline=yqhstart, refgaps=refgaps, querygaps=querygaps)
       }
    }
    par(mar=c(5,4,0,1))
    plotaligns(aligns, numplots, suppressaxis=FALSE, suppresstitle=TRUE, chrommin=0, chrommax=floor(chromlength/axisunitbases+1), vertline=yqhstart, vertlinelabel='Yqh', refgaps=refgaps, querygaps=querygaps)
  }
  if (!is.na(chromplotfile)) {
    dev.off()
  }

}

querycoverage <- function(aligns, queryname) {
  queryaligns <- aligns[aligns$query==queryname, ]
  covgsum <- sum(abs(queryaligns$queryend - queryaligns$querystart + 1))
  
  return(covgsum)
}

refcoverage <- function(aligns, queryname) {
  queryaligns <- aligns[aligns$query==queryname, ]
  covgsum <- sum(abs(queryaligns$end - queryaligns$start + 1))
  
  return(covgsum)
}

gaplocs <- function(bedfile) {

  if (!is.na(bedfile)) {
    gaps <- read.table(bedfile, sep="\t", header=FALSE, comment.char="!")
    names(gaps) <- c("contig", "start", "end", "gapname")    
  } else {
    gaps <- NA
  }
  
  return(gaps)
}

aligns <- readaligns(chromfile)
chromplotfile <- chromfile
chromplotfile <- sub(".bed", ".pdf", chromplotfile)

if (is.na(vertline)) {
  multiplotaligns(aligns, chromlength=chromlength, chromplotfile, refgapfile=refgapfile, querygapfile=querygapfile) 
} else {
  multiplotaligns(aligns, chromlength=chromlength, chromplotfile, refgapfile=refgapfile, querygapfile=querygapfile, yqhstart=vertline)  
}

library(stringr)
args = commandArgs(trailingOnly=TRUE)

readsetname <- ifelse(!( is.na(args[1])), args[1], "illumina2x250mat")
genomename <- ifelse(!( is.na(args[2])), args[2], "v1.1")
outputdir <- ifelse(!( is.na(args[3])), args[3], ".")
plottitle <- ifelse(!( is.na(args[4])), args[4], paste(c("Discrepancy counts in ", readsetname, " vs ", genomename), sep="", collapse=""))

indelfile <- paste(c(outputdir, "/", readsetname, ".indelerrorstats.txt"), sep="", collapse="")
subsfile <- paste(c(outputdir, "/", readsetname, ".singlenucerrorstats.txt"), sep="", collapse="")
plotname <- paste(c(outputdir, "/", readsetname, ".discrepancystats.", genomename, ".pdf"), sep="", collapse="")
pdf(plotname, 8.5, 5.5)
assembly_compound_plot(subsfile, indelfile, readsetname, titleval=plottitle)
dev.off()

#setwd("/Users/nhansen/HG002_diploid_benchmark/plots/readerrors")

library(stringr)
args = commandArgs(trailingOnly=TRUE)

readsetname <- ifelse(!( is.na(args[1])), args[1], "illumina2x250mat")
genomename <- ifelse(!( is.na(args[2])), args[2], "v1.1")
outputdir <- ifelse(!( is.na(args[3])), args[3], ".")
plottitle <- ifelse(!( is.na(args[4])), args[4], paste(c("Indel Sizes in ", readsetname, " vs ", genomename), sep="", collapse=""))

makemultiplot <- function() {
  par(mfrow=c(2,2))
  plotindellengths("sequelII_15k", outputdir, titleval="SequelII_15k")
  plotindellengths("sequelII_20kb_20210812", outputdir, titleval="SequelII_20kb_20210812")
  plotindellengths("hifidcv1.1", outputdir, titleval="HiFi/DCv1.1")
  plotindellengths("hifirevio3cell", outputdir, titleval="HiFi Revio")
  plotindellengths("illumina2x250mat", outputdir, titleval="Illumina 2x250 (maternal)")
  plotindellengths("element_avitilongmat", outputdir, titleval="Element Aviti")
}

makebog2024posterplots <- function() {
  # plots saved in "PlotsForAdamsBOGPoster2024/" called SequelDCv1.1IndelErrorRates.pdf and RevioDCv1.1.IndelErrorRates.pdf
  plotindellengths("/Users/nhansen/HG002_diploid_benchmark/plots/assemblyerrorstats/sequel_DCv1.1_hap1.indelerrorstats.txt", ".", ymax=4.0, titleval="Sequel/DCv1.1")
  plotindellengths("/Users/nhansen/HG002_diploid_benchmark/plots/assemblyerrorstats/RevioWashUDCv1.2Hap1.indelerrorstats.txt", ".", ymax=4.0, titleval="Revio/DCv1.1")
}

indelfile <- paste(c(outputdir, "/", readsetname, ".indelerrorstats.txt"), sep="", collapse="")
plotname <- paste(c(outputdir, "/", readsetname, ".indelsizestats.", genomename, ".pdf"), sep="", collapse="")
pdf(plotname, 8.5, 5.5)
plotindellengths(indelfile, outputdir, titleval=plottitle)
dev.off()

library(colorspace)
library(Hmisc)
library(plotrix)

readlengths <- function(sizefile) {
  clusterlengths <- read.table(sizefile, sep="\t", header=FALSE)
  names(clusterlengths) <- c("perc", "clusterlength", "totallength", "chromosome")
  clusterlengths$clusterlength <- clusterlengths$clusterlength/1000000
  
  return(clusterlengths)
}

readideallengths <- function(bedfile) {
  idealdf <- read.table(bedfile)
  idealdf$lengths <- (as.integer(idealdf$V3)-as.integer(idealdf$V2))/1000000
  
  totallengths <- sum(idealdf$lengths)
  sortedlengths <- sort(idealdf$lengths, decreasing=TRUE)
  perccovered <- sapply(seq(1, length(sortedlengths)), function(i) {return(100*sum(sortedlengths[seq(1,i)])/totallengths)})
  
  return(data.frame(clusterlength=sortedlengths, perc=perccovered))
}

plotclusterlengths <- function(clusterlengths, color="red", title="NGAx", dashed=FALSE, ltyval=NA, cexval=1.0, xmax=100, xlabel=NA) {
  xcoords <- append(0, clusterlengths$perc)
  ycoords <- c(clusterlengths$clusterlength, 0)
  if (is.na(ltyval)) {
    ltyval <- ifelse(dashed, 2, 1)
  }
  if (is.na(xlabel)) {
    xlabel="Percent of Diploid Genome"
  }
  plot(xcoords, ycoords, type="s", col=color, lty=ltyval, xlim=c(0,xmax), ylim=c(0,250), xlab=xlabel, ylab="Aligned length (Mb)", main=title, cex=cexval)
}

addclusterlengths <- function(clusterlengths, color="blue", dashed=FALSE, ltyval=NA) {
  xcoords <- append(0, clusterlengths$perc)
  ycoords <- c(clusterlengths$clusterlength, 0)
  if (is.na(ltyval)) {
    ltyval <- ifelse(dashed, 2, 1)
  }
  lines(xcoords, ycoords, type="s", col=color, lty=ltyval, xlim=c(0,100))
}

plotsingleassemblyresults <- function(clusterfile, contigfile, scaffoldfile, ideal=TRUE, haplotype="MAT", plottitle="") {
  cluster_lengths <- readlengths(clusterfile)
  contig_lengths <- readlengths(contigfile)
  scaffold_lengths <- readlengths(scaffoldfile)
  
  plotclusterlengths(cluster_lengths, col="red", title=plottitle)
  addclusterlengths(contig_lengths, col="blue")
  addclusterlengths(scaffold_lengths, col="darkgreen")
  if (ideal) {
    addclusterlengths(ideallengths, col="black")
  }
  
  if (ideal) {
    legend("topright", c("ideal", "NGx (scaffolds)", "NGx (contigs)", "NGAx"), bty="n", col=c("black", "darkgreen", "blue", "red"), pch=15)
  }
  else {
    legend("topright", c("NGx (scaffolds)", "NGx (contigs)", "NGAx"), bty="n", col=c("darkgreen", "blue", "red"), pch=15)
  }
}

assembly_ngax_plot <- function(clusterfiles, contigfiles=c(), scaffoldfiles=c(), assemblylabels=c(), idealfile="Figure3Output/hg002v1.1.alignclusterlengths.txt", ideal=FALSE, haplotype=NA, halfperc=FALSE, plottitle="", cexval=1.0) {
  
  firstclusters <- readlengths(clusterfiles[1])
  if (halfperc) {
    firstclusters$perc <- firstclusters$perc/2
  }
  if (is.na(haplotype)) {
    plotclusterlengths(firstclusters, col=assemblycolors[1], title=plottitle, lty=1, cexval=cexval, xmax=100, xlabel="Percent of Diploid Genome")
  }
  else {
    plotclusterlengths(firstclusters, col=assemblycolors[1], title=plottitle, lty=1, cexval=cexval, xmax=100)
  }
  if (length(contigfiles) > 1) {
    firstcontigs <- readlengths(contigfiles[1])
    if (halfperc) {
      firstcontigs$perc <- firstcontigs$perc/2
    }
    addclusterlengths(firstcontigs, col=assemblycolors[1])    
  }
  if (length(scaffoldfiles) > 1) {
    firstscaffolds <- readlengths(scaffoldfiles[1])
    if (halfperc) {
      firstscaffolds$perc <- firstscaffolds$perc/2
    }
    addclusterlengths(firstscaffolds, col=assemblycolors[1])    
  }
  
  if (length(clusterfiles) > 1) {
    for (i in seq(2, length(clusterfiles))) {
      clusters <- readlengths(clusterfiles[i])
      if (halfperc) {
        clusters$perc <- clusters$perc/2
      }
      addclusterlengths(clusters, col=assemblycolors[i], lty=1)
    }
  }
  if (ideal) {
    ideallengths <- readideallengths(idealfile)
    addclusterlengths(ideallengths, col="black")
    assemblycolors <- c(assemblycolors[1:length(assemblylabels)], "black")
    assemblylabels <- c(assemblylabels, "Ideal (HG002v1.1)")
  }
  legend("topright", assemblylabels, col=assemblycolors, bty="n", lty=rep(1, length(clusterfiles)))
  
}

# Routines for plotting homopolymer accuracy:

readmnstatsfile <- function(filename) {
  mnstats <- read.table(filename, header=FALSE, sep="\t")
  names(mnstats) <- c("name", "base", "reflength", "assemblylength", "type")
  
  return(mnstats) 
}

mononucaccuracystats <- function(mnstats) {
  consensuserrors <- mnstats[(mnstats$assemblylength != -1) & (mnstats$type == "CONSENSUS") & (mnstats$reflength >= 10) & (mnstats$reflength < 100), ]
  noncomplexcovered <- mnstats[mnstats$assemblylength != -1 & (mnstats$reflength >= 10) & (mnstats$reflength < 100), ]
  consensuserrorcounts <- hist(consensuserrors$reflength, plot=FALSE, breaks=seq(10, 100, 1))
  noncomplexcovcounts <- hist(noncomplexcovered$reflength, plot=FALSE, breaks=seq(10, 100, 1))
  accrate <- 1.0 - consensuserrorcounts$counts/noncomplexcovcounts$counts
  correctcalls <- noncomplexcovcounts$counts - consensuserrorcounts$counts
  
  return(data.frame(lengths=consensuserrorcounts$mids, errors=consensuserrorcounts$counts, correctcalls=correctcalls, totals=noncomplexcovcounts$counts, accuracy=accrate) ) 
}

assembly_mononucacc_plot <- function(mnstatsfiles=c(), assemblylabels=c(), plottitle="", pointcex=1.0, errorbars=FALSE, legendxpos=15, legendypos=0.6) {
  pchvalues <- c(15, 16, 17, 18, 15, 16, 17, 18, 15, 16, 17, 18)
  multiplevector <- c(1.4, 1.4, 1.4, 1.9, 1.4, 1.4, 1.4, 1.4, 1.4, 1.4, 1.4, 1.9)
  ptexp <- pointcex*multiplevector
  
  if (length(mnstatsfiles) > 0) {
    firststats <- readmnstatsfile(mnstatsfiles[1])
    genomename <- assemblylabels[1]
    
    plotdata <- mononucaccuracystats(firststats)    
    mnlengths <- plotdata[seq(1,30), "lengths"]
    accuracies <- plotdata[seq(1,30), "accuracy"]
    accconfints <- binconf(plotdata[seq(1,30), "correctcalls"], plotdata[seq(1,30), "totals"], return.df=TRUE)
    lowaccs <- accconfints$Lower
    highaccs <- accconfints$Upper
    plot(mnlengths, accuracies, xlim=c(10,40), ylim=c(0.0,1.0), pch=pchvalues[1], cex=ptexp[1], col=assemblycolors[1], xlab=c("Mononucleotide run length"), ylab=c("Accuracy"), main=c("Accuracy of mononucleotide runs"))
    #text(20, 0.5, labels= paste(c("Overall error rate: ", mononucerrorperc, "%"), sep="", collapse=""))
    if (errorbars) {
      arrows(x0=mnlengths, y0=lowaccs, x1=mnlengths, y1=highaccs, code=3, angle=90, length=0.1, col=assemblycolors[1])
    }
  }
  if (length(mnstatsfiles) > 1) {
    for (i in seq(2, length(mnstatsfiles))) {
      nextstats <- readmnstatsfile(mnstatsfiles[i])
      plotdata <- mononucaccuracystats(nextstats)
      mnlengths <- plotdata[seq(1,30), "lengths"]
      accuracies <- plotdata[seq(1,30), "accuracy"]
      accconfints <- binconf(plotdata[seq(1,30), "correctcalls"], plotdata[seq(1,30), "totals"], return.df=TRUE)
      lowaccs <- accconfints$Lower
      highaccs <- accconfints$Upper
      points(mnlengths, accuracies, xlim=c(10,40), cex=ptexp[i], pch=pchvalues[i], col=assemblycolors[i])
      if (errorbars) {
        arrows(x0=mnlengths, y0=lowaccs, x1=mnlengths, y1=highaccs, code=3, angle=90, length=0.1, col=assemblycolors[i])
      }
    }    
  }
  
  legend(legendxpos, legendypos, assemblylabels, bty="n", col=assemblycolors, pch=pchvalues, pt.cex=ptexp)
}

assembly_mononucqv_plot <- function(mnstatsfiles=c(), assemblylabels=c(), plottitle="", plotlines=FALSE, linetype=1, errorbars=FALSE, pointcex=1.0) {
  pchvalues <- c(15, 16, 17, 18, 15, 16, 17, 18, 15, 16, 17, 18)
  multiplevector <- c(1.4, 1.4, 1.4, 1.9, 1.4, 1.4, 1.4, 1.9, 1.4, 1.4, 1.4, 1.9)
  ptexp <- pointcex*multiplevector
  
  if (length(mnstatsfiles) > 0) {
    firststats <- readmnstatsfile(mnstatsfiles[1])
    genomename <- assemblylabels[1]
    plotdata <- mononucaccuracystats(firststats)    
    mnlengths <- plotdata[seq(1,30), "lengths"]
    errorrates <- plotdata[seq(1,30), "errors"]/plotdata[seq(1,30), "totals"]
    errorconfints <- binconf(plotdata[seq(1,30), "errors"], plotdata[seq(1,30), "totals"], return.df=TRUE)
    lowqvals <- -10.0*log10(errorconfints$Lower)
    highqvals <- -10.0*log10(errorconfints$Upper)
    
    qvals <- sapply(errorrates, function(x) { qv=-10.0*log10(x); return(qv) })
    if (plotlines) {
      plot(mnlengths, qvals, xlim=c(10,40), ylim=c(0, 35), type='l', lty=linetype, pch=pchvalues[1], col=assemblycolors[1], xlab=c("Mononucleotide run length"), ylab=c("Phred QV Score"), main=c("Accuracy of mononucleotide runs"))
    }
    else {
      plot(mnlengths, qvals, xlim=c(10,40), ylim=c(0, 35), pch=pchvalues[1], col=assemblycolors[1], xlab=c("Mononucleotide run length"), ylab=c("Phred QV Score"), main=c("Accuracy of mononucleotide runs"), cex=ptexp[1])
    }
    if (errorbars) {
      arrows(x0=mnlengths, y0=lowqvals, x1=mnlengths, y1=highqvals, code=3, angle=90, length=0, col=assemblycolors[1])
    }
  }
  if (length(mnstatsfiles) > 1) {
    for (i in seq(2, length(mnstatsfiles))) {
      nextstats <- readmnstatsfile(mnstatsfiles[i])
      plotdata <- mononucaccuracystats(nextstats)
      mnlengths <- plotdata[seq(1,30), "lengths"]
      errorrates <- plotdata[seq(1,30), "errors"]/plotdata[seq(1,30), "totals"]
      errorconfints <- binconf(plotdata[seq(1,30), "errors"], plotdata[seq(1,30), "totals"], return.df=TRUE)
      lowqvals <- -10.0*log10(errorconfints$Lower)
      highqvals <- -10.0*log10(errorconfints$Upper)
      
      qvals <- sapply(errorrates, function(x) { qv=-10.0*log10(x); return(qv) })
      if (plotlines) {
        points(mnlengths, qvals, xlim=c(10,40), type='l', lty=linetype, pch=pchvalues[i], col=assemblycolors[i])
      }
      else {
        points(mnlengths, qvals, xlim=c(10,40), cex=ptexp[i], pch=pchvalues[i], col=assemblycolors[i])
      }
      if (errorbars) {
        arrows(x0=mnlengths, y0=lowqvals, x1=mnlengths, y1=highqvals, code=3, angle=90, length=0, col=assemblycolors[i])
      }
    }    
  }

  if (plotlines) {
    legend("topright", assemblylabels, bty="n", col=assemblycolors, lty=linetype)
  } 
  else {
    legend("topright", assemblylabels, bty="n", col=assemblycolors, pch=pchvalues, pt.cex=pointcex*multiplevector)
  }
  #legend(30, 30, assemblylabels, col=assemblycolors, pch=pchvalues)
}

# Routines for plotting substitution rate-by-type histogram:

typeorder <- c("A_C", "A_G", "A_T", "T_C", "T_G", "T_A", "G_A", "G_T", "G_C", "C_A", "C_T", "C_G")
titv <- c("tv", "ti", "tv", "ti", "tv", "tv", "ti", "tv", "tv", "tv", "ti", "tv" )

cnvrt.coords <-function(x,y=NULL){
  xy <- xy.coords(x, y, recycle=TRUE)
  cusr <- par('usr')
  cplt <- par('plt')  
  plt <- list()
  plt$x <- (xy$x-cusr[1])/(cusr[2]-cusr[1])
  plt$y <- (xy$y-cusr[3])/(cusr[4]-cusr[3])
  fig <- list()
  fig$x <- plt$x*(cplt[2]-cplt[1])+cplt[1]
  fig$y <- plt$y*(cplt[4]-cplt[3])+cplt[3]
  return( list(fig=fig) )
}

plotpartialbarplot <- function(fn, x, y=NULL, barpositions=c(), barlabels=c()){
  old.par <- par(no.readonly=TRUE)
  on.exit(par(old.par))
  xy <- xy.coords(x, y)
  xy <- cnvrt.coords(xy)$fig
  par(plt=c(xy$x,xy$y), new=TRUE)
  output <- fn
  #text(output, barpositions, barlabels, pos=3, xpd=NA)
  tmp.par <- par(no.readonly=TRUE)
  return(invisible(tmp.par))
}

assembly_substitutions_plot <- function(assemblysubsfiles, assemblylabels, cexnames=1.0, xlabval="Assembly", ylabval="Substitutions per mb", titleval="", ymax=NA, legendxpos=5, legendypos=160.0, legendlabels=c(), legend=TRUE) {
  
  # note that the GQC "singlenucerrorstats.txt" output file does *not* include phasing errors (errors that match the opposite haplotype allele), only consensus
  firsthist <- read.table(assemblysubsfiles[1], sep="\t", col.names=c("errortype", "errorcount", "errorspermbaligned"))
  typeorderindex <- sapply(firsthist$errortype, function(x) {which(typeorder==x)})
  if (length(firsthist$errortype)>0) {
    firsttis <- sum(firsthist[titv[typeorderindex]=="ti", "errorspermbaligned"])
    firsttvs <- sum(firsthist[titv[typeorderindex]=="tv", "errorspermbaligned"])
  }
  else {
    firsttis <- 0
    firsttvs <- 0
  }
  tivals <- c(firsttis)
  tvvals <- c(firsttvs)
  assemblylabelswithtitv <- sapply(assemblylabels, function(x) {label = paste(c("Ti     Tv\n", x), sep="", collapse=""); return(label)})
 
  if (length(assemblysubsfiles) > 1) {
    for (i in seq(2, length(assemblysubsfiles))) {
      subshist <- read.table(assemblysubsfiles[i], sep="\t", col.names=c("errortype", "errorcount", "errorspermbaligned"))
      typeorderindex <- sapply(subshist$errortype, function(x) {which(typeorder==x)})
     
      if (length(subshist$errortype)>0) {
        assemblytis <- sum(subshist[titv[typeorderindex]=="ti", "errorspermbaligned"])
        assemblytvs <- sum(subshist[titv[typeorderindex]=="tv", "errorspermbaligned"])
      } 
      else {
        assemblytis <- 0
        assemblytvs <- 0
      }
      tivals <- append(tivals, assemblytis)
      tvvals <- append(tvvals, assemblytvs)
    }
  }

  if (is.na(ymax)) {
      ymax <- max(c(tivals, tvvals))*1.3    
  }
  
  barcolors <- sapply(assemblycolors, function(x) {c(darken(x), lighten(x, 0.3))})

  if (length(legendlabels) == 0) {
    legendlabels <- assemblylabels
  }    
  if (is.na(ymax)) {
    out <- barplot(rbind(tivals, tvvals), names.arg=assemblylabelswithtitv, beside=TRUE, cex.names=cexnames, col=barcolors, main=titleval, xlab=xlabval, ylab=ylabval)
  }
  else {
    out <- barplot(rbind(tivals, tvvals), names.arg=assemblylabelswithtitv, beside=TRUE, cex.names=cexnames, col=barcolors, main=titleval, xlab=xlabval, ylab=ylabval, ylim=c(0,ymax))
  }

  if (legend) {
    legend(legendxpos, legendypos, legendlabels, bty="n", col=assemblycolors, pch=15)
  }
  formattedrates <- as.integer(rbind(tivals, tvvals)*10+0.5)/10
  text(out, rbind(tivals, tvvals), formattedrates, pos=3, xpd=NA)
  return(out)
}

# Routines for plotting indel rates:

totalindelrate <- function(indellengthfile) {
  indellengthhist <- read.table(indellengthfile, sep="\t")
  names(indellengthhist) <- c("indellength", "indelcount", "indelspermbaligned")
  
  return(sum(indellengthhist$indelspermbaligned, na.rm=TRUE))  
}
totalinsertionrate <- function(indellengthfile) {
  indellengthhist <- read.table(indellengthfile, sep="\t")
  names(indellengthhist) <- c("indellength", "indelcount", "indelspermbaligned")
  
  return(sum(indellengthhist[indellengthhist$indellength>0, "indelspermbaligned"], na.rm=TRUE))  
}
totaldeletionrate <- function(indellengthfile) {
  indellengthhist <- read.table(indellengthfile, sep="\t")
  names(indellengthhist) <- c("indellength", "indelcount", "indelspermbaligned")
  
  return(sum(indellengthhist[indellengthhist$indellength<0, "indelspermbaligned"], na.rm=TRUE))  
}
assembly_indels_plot <- function(indellengthfiles, assemblylabels, xlabval="Assembly", ylabval="Indel Errors per mb", cexnames=1.0, legendlabels=c(), legendxpos=5, legendypos=25.0, titleval="", ymax=NA) {
  totalinsertionrates <- sapply(indellengthfiles, totalinsertionrate)
  totaldeletionrates <- sapply(indellengthfiles, totaldeletionrate)
  
  assemblylabelswithinsdel <- sapply(assemblylabels, function(x) {label = paste(c("Ins     Del\n", x), sep="", collapse=""); return(label)})
  
  if (is.na(ymax)) {
    ymax <- max(c(totalinsertionrates, totaldeletionrates))*1.3    
  }
  
  barcolors <- sapply(assemblycolors, function(x) {c(darken(x), lighten(x, 0.3))})
  out <- barplot(rbind(totalinsertionrates, totaldeletionrates), beside=TRUE, names.arg=assemblylabelswithinsdel, cex.names=cexnames, col=barcolors, main=titleval, xlab=xlabval, ylab=ylabval, ylim=c(0,ymax))

  if (length(legendlabels) == 0) {
    legendlabels <- assemblylabels
  }    
  legend(out[legendxpos], legendypos, legendlabels, bty="n", col=assemblycolors, pch=15)
  formattedrates <- as.integer(rbind(totalinsertionrates, totaldeletionrates)*10+0.5)/10
  text(out, rbind(totalinsertionrates, totaldeletionrates), formattedrates, pos=3, xpd=NA)
  
}

# Routines for plotting quality values:

assembly_qv_plot <-function(assembly_stats_file, yak_stats_file, merq_stats_file, assemblynames, assemblylabels, titleval="Assembly QV by different methods", noyak=TRUE) {
  
  assembly_qv_stats <- read.table(assembly_stats_file, sep="\t", header=FALSE)
  names(assembly_qv_stats) <- c("Assembly", "QV")
  
  if (!(noyak)) {
    yak_qv_stats <- read.table(yak_stats_file, sep="\t", header=FALSE)
    names(yak_qv_stats) <- c("Assembly", "ErrorCount", "AssemblyCount", "QV", "Unused", "AssemblyFile")
  }
  
  merq_qv_stats <- read.table(merq_stats_file, sep="\t", header=FALSE)
  names(merq_qv_stats) <- c("Assembly", "ErrorCount", "AssemblyCount", "QV", "Unused")
  
  qvs_to_map <- data.frame("assembly"=assemblynames)
  qvs_to_map$assemblyqv <- sapply(assemblynames, function(x) {assembly_qv_stats[assembly_qv_stats$Assembly==x, "QV"]})
  if (!(noyak)) {
    qvs_to_map$yakqv <- sapply(assemblynames, function(x) {yak_qv_stats[yak_qv_stats$Assembly==x, "QV"]})
  }
  qvs_to_map$merqqv <- sapply(assemblynames, function(x) {merq_qv_stats[merq_qv_stats$Assembly==x, "QV"]})
  benchmarkmerq <- merq_qv_stats[merq_qv_stats$Assembly=="hg002v1.1", "QV"]
  
  #return(qvs_to_map)
  if (!(noyak)) {
    minqv <- min(rbind(qvs_to_map$assemblyqv, qvs_to_map$yakqv, qvs_to_map$merqqv), na.rm=TRUE)
    maxqv <- max(rbind(qvs_to_map$assemblyqv, qvs_to_map$yakqv, qvs_to_map$merqqv), na.rm=TRUE)
    if (maxqv<benchmarkmerq) {
      maxqv <- benchmarkmerq + 10
    }
    barplot(t(cbind(qvs_to_map$yakqv, qvs_to_map$merqqv, qvs_to_map$assemblyqv)), beside=TRUE, names.arg=assemblylabels, cex.names=0.7, col=qvmethodcolors, xlab="Assembly", ylim=c(0, maxqv+20), main=titleval)
    abline(h=benchmarkmerq, lty=3)
    text(5, benchmarkmerq, "HG002v1.1 Merqury", pos=2)
    legend("topright", c("Yak", "Merqury", "GQC Benchmark"), col=qvmethodcolors, pch=15)
  } else {
    barplotmethodcolors <- qvmethodcolors[2:3]
    minqv <- min(rbind(qvs_to_map$assemblyqv, qvs_to_map$merqqv), na.rm=TRUE)
    maxqv <- max(rbind(qvs_to_map$assemblyqv, qvs_to_map$merqqv), na.rm=TRUE)
    if (maxqv<benchmarkmerq) {
      maxqv <- benchmarkmerq + 10
    }
    barplot(t(cbind(qvs_to_map$yakqv, qvs_to_map$merqqv, qvs_to_map$assemblyqv)), beside=TRUE, names.arg=assemblylabels, cex.names=0.7, col=barplotmethodcolors, xlab="Assembly", ylim=c(0, maxqv+20), main=titleval)
    abline(h=benchmarkmerq, lty=3)
    text(5, benchmarkmerq, "HG002v1.1 Merqury", pos=2)
    legend("topright", c("Merqury", "GQC Benchmark"), bty="n", col=barplotmethodcolors, pch=15)
  }
}

# Routines for plotting sideways barplot of switch rates

assembly_switchrate_plot <- function(assemblynames, assemblylabels, switchfile=phaseswitchfile, plottitle="Phase switch errors per megabase") {
  switchrates <- read.table(switchfile, sep="\t", header=FALSE)
  names(switchrates) <- c("Assembly", "SwitchRate")
  
  # bottom, left, top, right  
  defaultmargin <- c(5.1, 4.1, 4.1, 2.1)
  par(mar = c(5.1, 9.1, 4.1, 4.1))
  #par(mar = c(5.1, 10.1, 4.1, 4.1))
  options(scipen=8)
  
  assemblyswitchrates <- sapply(assemblynames, function(x) {switchrates[switchrates$Assembly==x, "SwitchRate"]})
  
  out <- barplot(rev(log10(as.numeric(assemblyswitchrates))), names.arg=rev(assemblylabels), las=1, horiz=TRUE, xaxt='n', col=rev(assemblycolors[1:length(assemblynames)]), xlab=c("Errors per megabase"), main=plottitle)
  xval <- c(1, 10, 100, 1000)
  xpos <- log10(xval)
  axis(1, xpos, xval, las=1)
  formattedrates <- as.integer(assemblyswitchrates*10+0.5)/10
  text(log10(rev(assemblyswitchrates)), out, rev(formattedrates), pos=4, xpd=NA)
  par(mar=defaultmargin)
  
}

# Routines for plotting sideways barplot of switch rates

assembly_missingness_plot <- function(assemblynames, assemblylabels, missingnessfile=missingfile, plottitle="Uncovered HG002v1.1 bases") {
  missingbases <- read.table(missingfile, sep="\t", header=FALSE)
  names(missingbases) <- c("Assembly", "MissingBases")
  
  # bottom, left, top, right  
  defaultmargin <- c(5.1, 4.1, 4.1, 2.1)
  par(mar = c(5.1, 9.1, 4.1, 4.1))
  #par(mar = c(5.1, 10.1, 4.1, 4.1))
  options(scipen=8)
  
  assemblymissingrates <- sapply(assemblynames, function(x) {missingbases[missingbases$Assembly==x, "MissingBases"]})
  assemblymissingrates <- assemblymissingrates/1000000
  #return(assemblymissingrates) 
  
  out <- barplot(rev(log10(as.numeric(assemblymissingrates))), names.arg=rev(assemblylabels), las=1, horiz=TRUE, xaxt='n', col=rev(assemblycolors[1:length(assemblynames)]), xlab=c("Missing bases (Mb)"), main=plottitle)
  xval <- c(1, 10, 100, 1000)
  xpos <- log10(xval)
  axis(1, xpos, xval, las=1)
  formattedrates <- as.integer(assemblymissingrates*10+0.5)/10
  text(log10(rev(assemblymissingrates)), out, rev(formattedrates), pos=4, xpd=NA)
  par(mar=defaultmargin)

  return(assemblymissingrates) 
}

#setwd("/Users/nhansen/HG002_diploid_benchmark/plots")

#if (!requireNamespace("BiocManager", quietly = TRUE))
  #install.packages("BiocManager")
#if (!requireNamespace("karyoploteR", quietly = TRUE))
  #BiocManager::install("karyoploteR")

library(stringr)
library(karyoploteR)
args = commandArgs(trailingOnly=TRUE)

genomename <- ifelse(!( is.na(args[1])), args[1], "year1pat")
outputdir <- ifelse(!( is.na(args[2])), args[2], ".")
resourcedir <- ifelse(! ( is.na(args[3])), args[3], ".")
benchname <- ifelse(!( is.na(args[4])), args[4], "v1.1")
plottitle <- ifelse(!( is.na(args[5])), args[5], paste(c(genomename, " aligned coverage vs. v1.1"), sep="", collapse=""))
genomefile <- paste(c(outputdir, "/genome.", genomename, ".bed"), sep="", collapse="")
scaffolds <- toGRanges(genomefile)
scaffolds <- sort(scaffolds)
scaffolddf <- read.table(genomefile, sep="\t", comment.char="", header=FALSE)
seqlengths(scaffolds) <- scaffolddf[,3]
bigscaffolds <- sort(seqlengths(scaffolds), decreasing=TRUE)
chroms <- names(bigscaffolds)
if (length(chroms) > 40){
  chroms <- chroms[1:40]
}

#matcoveredfile <- paste(c(outputdir, "/testmatcovered.", genomename, ".merged.bed"), sep="", collapse="")
#patcoveredfile <- paste(c(outputdir, "/testpatcovered.", genomename, ".merged.bed"), sep="", collapse="")
matcoveredfile <- paste(c(outputdir, "/testmatcovered.", genomename, ".bed"), sep="", collapse="")
patcoveredfile <- paste(c(outputdir, "/testpatcovered.", genomename, ".bed"), sep="", collapse="")
matcoveredranges <- toGRanges(matcoveredfile)
patcoveredranges <- toGRanges(patcoveredfile)

nlocfile <- paste(c(outputdir, "/nlocs.", genomename, ".bed"), sep="", collapse="")
nlocranges <- toGRanges(nlocfile)

pp <- getDefaultPlotParams(plot.type=1)
pp$ideogramheight <- 100
pp$topmargin <- 300

plotname <- paste(c(outputdir, "/", genomename, ".testcovered.", benchname, ".pdf"), sep="", collapse="")
pdf(plotname, 8.5, 11.0)
#kp <- plotKaryotype(genome=scaffolds,chromosomes=paste0("chr", c(1:22, "X", "Y")), plot.type=1, main=plottitle)
kp <- plotKaryotype(genome=scaffolds, plot.type=1, chromosomes=chroms, main=plottitle, cex=0.5, plot.params=pp)
kpAddBaseNumbers(kp, tick.dist = 10000000, tick.len = 10, tick.col="red")
if (length(nlocranges) > 0)
    kpRect(kp, data=nlocranges, col="red", data.panel="ideogram", y0=rep(0, length(nlocranges)), y1=rep(1, length(nlocranges)))
if (length(patcoveredranges) > 0)
    kpRect(kp, data=patcoveredranges, col="blue", data.panel="ideogram", y0=rep(0, length(patcoveredranges)), y1=rep(1, length(patcoveredranges)))
if (length(matcoveredranges) > 0)
    kpRect(kp, data=matcoveredranges, col="green", data.panel="ideogram", y0=rep(0, length(matcoveredranges)), y1=rep(1, length(matcoveredranges)))

legend("bottomright", c("Paternal", "Maternal", "Ns"), fill=c("blue", "green", "red"))

dev.off()

#setwd("/Users/nhansen/HG002_diploid_benchmark/plots/readaligns")

args = commandArgs(trailingOnly=TRUE)

readsetname <- ifelse(!( is.na(args[1])), args[1], "illumina2x250mat")
genomename <- ifelse(!( is.na(args[2])), args[2], "v1.0.1")
outputdir <- ifelse(!( is.na(args[3])), args[3], ".")
plottitle <- ifelse(!( is.na(args[4])), args[4], paste(c("Homopolymer length concordance for ", readsetname, " vs ", genomename), sep="", collapse=""))

readmononuchist <- function(filename) {
  mndf <- read.table(filename, header=TRUE, sep="")
  names(mndf) <- c("reflength", "readlength", "numcorrect", "numhetallele", "numerror", "numcomplex")
  mndf <- mndf[mndf$readlength != -1, ]
  mndf$reflength <- as.integer(mndf$reflength)
  mndf$readlength <- as.integer(mndf$readlength)
  mndf$numcorrect <- as.integer(mndf$numcorrect)
  mndf$numerror <- as.integer(mndf$numerror)
  
  return(mndf)
}

mndiffs <- function(filename, i) {
  mndiff <- readmononuchist(filename);
  
  if (i==0) {
    diffcount <- sum(mndiff[mndiff$readlength==mndiff$reflength, "numcorrect"])
  }
  else {
    diffcount <- sum(mndiff[mndiff$readlength-mndiff$reflength==i, "numerror"])
  }
  return(diffcount)
}

onebaseindelratio <- function(filename) {
  onebaseratio <- mndiffs(filename, 1)*1.0/mndiffs(filename, -1)
  
  return(onebaseratio)
}

diffarray <- function(filename, maxdiff=4) {
  platformdiffs <- sapply(seq(-1*maxdiff, maxdiff), function(i) {mndiffs(filename, i)})
  platformdiffs <- platformdiffs/sum(platformdiffs)
  
  return(platformdiffs)
}

makemultiplot <- function(maxdiff=4) {
  plotcolors <- c("blue", "lightblue", "lightgreen", "darkgreen", "violet", "darkviolet")
  par(oma=c(5,5,5,5))
  par(mfrow = c(2, 3))
  barplot(diffarray("sequelII_15k.mononuchist.txt", maxdiff=maxdiff), names=seq(-1*maxdiff, maxdiff), col=plotcolors[1], cex.names=1.0, main="SequelII_15k", xlab="Difference from benchmark", ylab="Fraction of reads")
  barplot(diffarray("sequelII_20kb_20210812.mononuchist.txt", maxdiff=maxdiff), names=seq(-1*maxdiff, maxdiff), col=plotcolors[2], cex.names=1.0, main="SequelII_20kb_20210812", xlab="Difference from benchmark")
  barplot(diffarray("hifidcv1.1.mononuchist.txt", maxdiff=maxdiff), names=seq(-1*maxdiff, maxdiff), col=plotcolors[3], cex.names=1.0, main="HiFi/DCv1.1", xlab="Difference from benchmark")
  barplot(diffarray("hifirevio3cells.mononuchist.txt", maxdiff=maxdiff), names=seq(-1*maxdiff, maxdiff), col=plotcolors[4], cex.names=1.0, main="HiFi Revio", xlab="Difference from benchmark")
  barplot(diffarray("illumina2x250mat.mononuchist.txt", maxdiff=maxdiff), names=seq(-1*maxdiff, maxdiff), col=plotcolors[5], cex.names=0.7, main="Illumina 2x250 (maternal)", xlab="Difference from benchmark")
  barplot(diffarray("element_avitilongmat.mononuchist.txt", maxdiff=maxdiff), names=seq(-1*maxdiff, maxdiff), col=plotcolors[6], cex.names=0.7, main="Element Aviti (maternal)", xlab="Difference from benchmark")
  mtext("Homopolymer length concordance", side = 3, line = 1, outer = TRUE)
}

plotmononuchist <- function(file, plottitle="", maxdiff=4){
  differences <- diffarray(file, maxdiff=maxdiff)
  accrate <- as.integer(differences[maxdiff+1]*1000)/10
  barplot(differences, names=seq(-1*maxdiff,maxdiff), col="blue", cex.names=1.0, main=plottitle, xlab="Difference from benchmark", ylab="Fraction of reads", ylim=c(0,1.0))
  mtext(paste(c("Accuracy: ", as.character(accrate), "%"), sep="", collapse=""), side=3, adj=0.85, line=-4)
  indelratio <- as.integer(onebaseindelratio(file)*1000)/1000
  mtext(paste(c("1bp Ins/Dels: ", as.character(indelratio)), sep="", collapse=""), side=3, adj=0.85, line=-5 )
}

plotmononucaccuracy <- function(file, plottitle=NA, minlength=NA, maxlength=NA, color="black"){
  mncounts <- readmononuchist(file)
  if(is.na(minlength)) {
    minlength <- min(mncounts$reflength)
  }
  if(is.na(maxlength)) {
    maxlength <- max(mncounts$reflength)
  }
  if(is.na(plottitle)) {
    plottitle <- paste(c("Accuracy of mononucleotide runs in ", genomename), sep="", collapse="")
  }
  accarray <- sapply(seq(minlength, maxlength), function(x) {sum(mncounts[mncounts$reflength==x, "numcorrect"])/sum(mncounts[mncounts$reflength==x, "numerror"] + mncounts[mncounts$reflength==x, "numcorrect"])})
  #  names(mndf) <- c("reflength", "readlength", "numcorrect", "numhetallele", "numerror", "numcomplex")
  totalaccrate <- as.integer(sum(mncounts$numcorrect)*1000/sum(mncounts$numerror+mncounts$numcorrect))/10
  plot(seq(minlength, maxlength), accarray, pch=16, xlab=c("Mononucleotide run length"), ylab=c("Accuracy"), main=plottitle, ylim=c(0,1), col=color)
  if (totalaccrate < 75) {
    textheight <- 0.9
    textpos <- minlength + 3*(maxlength-minlength)/4    
  }
  else {
    #textheight <- accarray[as.integer((maxlength-minlength)/3)]/2
    textheight <- 0.2
    textpos <- minlength + (maxlength-minlength)/4
  }
  text(textpos, textheight, labels= paste(c("Overall: ", totalaccrate, "%"), sep="", collapse=""))
}

par(mfrow=c(1,1))
mononucfile <- paste(c(outputdir, "/", readsetname, ".mononuchist.txt"), sep="", collapse="")

plotname <- paste(c(outputdir, "/", readsetname, ".mononucsizehist.pdf"), sep="", collapse="")
pdf(plotname, 8.5, 5.5)
plotmononuchist(mononucfile, plottitle, 4)
dev.off()

plotname <- paste(c(outputdir, "/", readsetname, ".mononucaccuracy.pdf"), sep="", collapse="")
pdf(plotname, 8.5, 5.5)
plotmononucaccuracy(mononucfile, plottitle, maxlength=40)
dev.off()

comparison_plot_may_2024 <- function(maxdiff=4) {
  plotcolors <- palette.colors(n=6)
  par(oma=c(5,5,5,5))
  par(mfrow = c(2, 3))
  barplot(diffarray("element_avitilongmat.mononuchist.txt", maxdiff=maxdiff), names=seq(-1*maxdiff, maxdiff), col=plotcolors[1], cex.names=0.7, main="Element Aviti (maternal)", xlab="Difference from benchmark", ylim=c(0,1))
  barplot(diffarray("illumina2x250mat_nonexc.mononuchist.txt", maxdiff=maxdiff), names=seq(-1*maxdiff, maxdiff), col=plotcolors[2], cex.names=0.7, main="Illumina 2x250 (maternal)", xlab="Difference from benchmark", ylim=c(0,1))
  barplot(diffarray("hifi_revio_pbmay24.mononuchist.txt", maxdiff=maxdiff), names=seq(-1*maxdiff, maxdiff), col=plotcolors[3], cex.names=1.0, main="HiFi Revio/Late 2023", xlab="Difference from benchmark", ylab="Fraction of reads", ylim=c(0,1))
  barplot(diffarray("ONT_Q28.mononuchist.txt", maxdiff=maxdiff), names=seq(-1*maxdiff, maxdiff), col=plotcolors[4], cex.names=1.0, main="ONT Q28/Nov 2023", xlab="Difference from benchmark", ylim=c(0,1))
  barplot(diffarray("ONT_R10_duplex_nonexc.mononuchist.txt", maxdiff=maxdiff), names=seq(-1*maxdiff, maxdiff), col=plotcolors[5], cex.names=1.0, main="ONT R10 Duplex", xlab="Difference from benchmark", ylim=c(0,1))
  barplot(diffarray("ONT_Q28_herrocorrected.mononuchist.txt", maxdiff=maxdiff), names=seq(-1*maxdiff, maxdiff), col=plotcolors[6], cex.names=1.0, main="Herro-corrected ONT", xlab="Difference from benchmark", ylim=c(0,1))
  mtext("Homopolymer length concordance", side = 3, line = 1, outer = TRUE)
}
accuracy_comparison_plot_may_2024 <- function() {
  plotcolors <- palette.colors(n=6)
  par(oma=c(5,5,5,5))
  par(mfrow = c(2, 3))
  plotmononucaccuracy("element_avitilongmat.mononuchist.txt", maxlength=40, color=plotcolors[1], plottitle="Element Aviti (maternal)")
  plotmononucaccuracy("illumina2x250mat_nonexc.mononuchist.txt", maxlength=40, color=plotcolors[2], plottitle="Illumina 2x250 (maternal)")
  plotmononucaccuracy("hifi_revio_pbmay24.mononuchist.txt", maxlength=40, color=plotcolors[3], plottitle="HiFi Revio/Late 2023")
  plotmononucaccuracy("ONT_Q28.mononuchist.txt", maxlength=40, color=plotcolors[4], plottitle="ONT Q28/Nov 2023")
  plotmononucaccuracy("ONT_R10_duplex_nonexc.mononuchist.txt", maxlength=40, color=plotcolors[5], plottitle="ONT R10 Duplex")
  plotmononucaccuracy("ONT_Q28_herrocorrected.mononuchist.txt", maxlength=40, color=plotcolors[6], plottitle="Herro-corrected ONT")
  mtext("Homopolymer length accuracy", side = 3, line = 1, outer = TRUE)
}

#setwd("/Users/nhansen/HG002_diploid_benchmark/plots/mononucplots")

library("Hmisc")

args = commandArgs(trailingOnly=TRUE)

genomename <- ifelse(!( is.na(args[1])), args[1], "ash1")
benchname <- ifelse(!( is.na(args[2])), args[2], "v1.1")
outputdir <- ifelse(!( is.na(args[3])), args[3], ".")
resourcedir <- ifelse(! ( is.na(args[4])), args[4], ".")
plottitle <- ifelse(!( is.na(args[5])), args[5], paste(c(genomename, " accuracy of mononucleotide runs"), sep="", collapse=""))

mononucsitefile <- paste(c(outputdir, "/", genomename, ".mononucstats.txt"), sep="", collapse="")
mononucsites <- read.table(mononucsitefile, header=FALSE, sep="\t", col.names=c("name", "base", "reflength", "assemblylength", "type"))

consensuserrors <- mononucsites[(mononucsites$assemblylength != -1) & (mononucsites$type == "CONSENSUS") & (mononucsites$reflength >= 10) & (mononucsites$reflength <= 100), ]
noncomplexcovered <- mononucsites[mononucsites$assemblylength != -1 & (mononucsites$reflength >= 10) & (mononucsites$reflength < 100), ]

if (length(noncomplexcovered$name) > 0) {
    mononucerrorrate <- length(consensuserrors$reflength)/length(noncomplexcovered$reflength)
    mononucerrorperc <- round(mononucerrorrate*100, 2)

    # Calculate error rate as consensus error counts divided by covered counts that aren't complex:
    
    consensuserrorcounts <- hist(consensuserrors$reflength, plot=FALSE, breaks=seq(10, 100, 1))
    noncomplexcovcounts <- hist(noncomplexcovered$reflength, plot=FALSE, breaks=seq(10, 100, 1))
    
    accrate <- 1.0 - consensuserrorcounts$counts/noncomplexcovcounts$counts
    assembly_mononucqv_plot(c(mononucsitefile), assemblylabels=c(genomename), plottitle="", plotlines=TRUE, linetype=1, errorbars=TRUE, overallerrorrate=mononucerrorperc)
    plotname <- paste(c(outputdir, "/", genomename, ".mononuc_accuracy.", benchname, ".pdf"), sep="", collapse="")
    pdf(plotname, 7.08661, 6.69291)
    assembly_mononucqv_plot(c(mononucsitefile), assemblylabels=c(genomename), plottitle="", plotlines=TRUE, linetype=1, errorbars=TRUE, overallerrorrate=mononucerrorperc)
    #text(20, 20, labels= paste(c("Overall error rate: ", mononucerrorperc, "%"), sep="", collapse=""))
    dev.off()
}
